/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.mmu.sim;

import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.mmu.model.sim.*;
import ru.ispras.fortress.data.types.bitvector.*;

/**
 * The {@code L2} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class L2 extends Cache<L2.Entry, PA> {
  private static L2 instance = null;

  public static L2 get() {
    if (null == instance) {
      instance = new L2();
    }
    return instance;
  }

  public static final class Entry implements Data {
    public final BitVector V;
    public final BitVector TAG;
    public final BitVector DATA;

    public Entry() {
      this.V = BitVector.valueOf(0x0, 1);
      this.TAG = BitVector.newEmpty(15);
      this.DATA = BitVector.newEmpty(256);
    }

    public Entry(final BitVector value) {
      this();
      asBitVector().assign(value);
    }

    public void assign(final Entry other) {
      this.V.assign(other.V);
      this.TAG.assign(other.TAG);
      this.DATA.assign(other.DATA);
    }

    @Override
    public BitVector asBitVector() {
      return BitVector.newMapping(
          DATA,
          TAG,
          V
          );
    }

    @Override
    public String toString() {
      return String.format(
          "Entry [V=0x%s, TAG=0x%s, DATA=0x%s]",
          V.toHexString(),
          TAG.toHexString(),
          DATA.toHexString()
          );
    }
  }
  private static final Indexer<PA> INDEXER = new Indexer<PA>() {
    @Override
    public BitVector getIndex(final PA pa) {
      return pa.value.field(16, 5);
    }
  };

  private static final Matcher<L2.Entry, PA> MATCHER = new Matcher<L2.Entry, PA>() {
    @Override
    public boolean areMatching(final L2.Entry data, final PA pa) {
      return data.V.equals(BitVector.valueOf(0x1, 1)) && data.TAG.equals(pa.value.field(31, 17));
    }
  };

  private L2() {
    super(
      new BigInteger("4096", 10),
      4,
      PolicyId.PLRU,
      INDEXER,
      MATCHER
      );
  }

  @Override
  protected PA newAddress() {
    return new PA();
  }

  @Override
  protected Entry newData(final BitVector value) {
    return new Entry(value);
  }
}
