/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv;

import ru.ispras.microtesk.model.ModelBuilder;
import ru.ispras.microtesk.model.riscv.metadata.MetaModelFactory;
import ru.ispras.microtesk.model.riscv.decoder.Decoder;
import ru.ispras.microtesk.model.riscv.mode.*;
import ru.ispras.microtesk.model.riscv.op.*;

/**
 * The {@code Model} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class Model extends ModelBuilder {
  public Model() {
    super(
        "riscv",
        "RV64FULL",
        MetaModelFactory.newMetaModel(),
        Decoder.get(),
        PE.newFactory(),
        TempVars.newFactory()
        );

    addMode(ZERO.INFO);
    addMode(RA.INFO);
    addMode(SP.INFO);
    addMode(GP.INFO);
    addMode(TP.INFO);
    addMode(TemporariesCaller.INFO);
    addMode(SavedCallee.INFO);
    addMode(FunctionCaller.INFO);
    addMode(X.INFO);
    addMode(FPTemporariesCaller.INFO);
    addMode(FPSavedCallee.INFO);
    addMode(FPArgumentsCaller.INFO);
    addMode(F.INFO);
    addMode(USTATUS.INFO);
    addMode(UIE.INFO);
    addMode(UTVEC.INFO);
    addMode(USCRATCH.INFO);
    addMode(UEPC.INFO);
    addMode(UCAUSE.INFO);
    addMode(UTVAL.INFO);
    addMode(UIP.INFO);
    addMode(FFLAGS.INFO);
    addMode(FRM.INFO);
    addMode(FCSR.INFO);
    addMode(CYCLE.INFO);
    addMode(TIME.INFO);
    addMode(INSTRET.INFO);
    addMode(HPMCOUNTER3.INFO);
    addMode(HPMCOUNTER4.INFO);
    addMode(HPMCOUNTER5.INFO);
    addMode(HPMCOUNTER6.INFO);
    addMode(HPMCOUNTER7.INFO);
    addMode(HPMCOUNTER8.INFO);
    addMode(HPMCOUNTER9.INFO);
    addMode(HPMCOUNTER10.INFO);
    addMode(HPMCOUNTER11.INFO);
    addMode(HPMCOUNTER12.INFO);
    addMode(HPMCOUNTER13.INFO);
    addMode(HPMCOUNTER14.INFO);
    addMode(HPMCOUNTER15.INFO);
    addMode(HPMCOUNTER16.INFO);
    addMode(HPMCOUNTER17.INFO);
    addMode(HPMCOUNTER18.INFO);
    addMode(HPMCOUNTER19.INFO);
    addMode(HPMCOUNTER20.INFO);
    addMode(HPMCOUNTER21.INFO);
    addMode(HPMCOUNTER22.INFO);
    addMode(HPMCOUNTER23.INFO);
    addMode(HPMCOUNTER24.INFO);
    addMode(HPMCOUNTER25.INFO);
    addMode(HPMCOUNTER26.INFO);
    addMode(HPMCOUNTER27.INFO);
    addMode(HPMCOUNTER28.INFO);
    addMode(HPMCOUNTER29.INFO);
    addMode(HPMCOUNTER30.INFO);
    addMode(HPMCOUNTER31.INFO);
    addMode(SSTATUS.INFO);
    addMode(SEDELEG.INFO);
    addMode(SIDELEG.INFO);
    addMode(SIE.INFO);
    addMode(STVEC.INFO);
    addMode(SCOUNTEREN.INFO);
    addMode(SSCRATCH.INFO);
    addMode(SEPC.INFO);
    addMode(SCAUSE.INFO);
    addMode(STVAL.INFO);
    addMode(SIP.INFO);
    addMode(SATP.INFO);
    addMode(MVENDORID.INFO);
    addMode(MARCHID.INFO);
    addMode(MIMPID.INFO);
    addMode(MHARTID.INFO);
    addMode(MSTATUS.INFO);
    addMode(MISA.INFO);
    addMode(MEDELEG.INFO);
    addMode(MIDELEG.INFO);
    addMode(MIE.INFO);
    addMode(MTVEC.INFO);
    addMode(MCOUNTEREN.INFO);
    addMode(MSCRATCH.INFO);
    addMode(MEPC.INFO);
    addMode(MCAUSE.INFO);
    addMode(MTVAL.INFO);
    addMode(MIP.INFO);
    addMode(PMPCFG0.INFO);
    addMode(PMPCFG1.INFO);
    addMode(PMPCFG2.INFO);
    addMode(PMPCFG3.INFO);
    addMode(PMPADDR0.INFO);
    addMode(PMPADDR1.INFO);
    addMode(PMPADDR2.INFO);
    addMode(PMPADDR3.INFO);
    addMode(PMPADDR4.INFO);
    addMode(PMPADDR5.INFO);
    addMode(PMPADDR6.INFO);
    addMode(PMPADDR7.INFO);
    addMode(PMPADDR8.INFO);
    addMode(PMPADDR9.INFO);
    addMode(PMPADDR10.INFO);
    addMode(PMPADDR11.INFO);
    addMode(PMPADDR12.INFO);
    addMode(PMPADDR13.INFO);
    addMode(PMPADDR14.INFO);
    addMode(PMPADDR15.INFO);
    addMode(MCYCLE.INFO);
    addMode(MINSTRET.INFO);
    addMode(MHPMCOUNTER3.INFO);
    addMode(MHPMCOUNTER4.INFO);
    addMode(MHPMCOUNTER5.INFO);
    addMode(MHPMCOUNTER6.INFO);
    addMode(MHPMCOUNTER7.INFO);
    addMode(MHPMCOUNTER8.INFO);
    addMode(MHPMCOUNTER9.INFO);
    addMode(MHPMCOUNTER10.INFO);
    addMode(MHPMCOUNTER11.INFO);
    addMode(MHPMCOUNTER12.INFO);
    addMode(MHPMCOUNTER13.INFO);
    addMode(MHPMCOUNTER14.INFO);
    addMode(MHPMCOUNTER15.INFO);
    addMode(MHPMCOUNTER16.INFO);
    addMode(MHPMCOUNTER17.INFO);
    addMode(MHPMCOUNTER18.INFO);
    addMode(MHPMCOUNTER19.INFO);
    addMode(MHPMCOUNTER20.INFO);
    addMode(MHPMCOUNTER21.INFO);
    addMode(MHPMCOUNTER22.INFO);
    addMode(MHPMCOUNTER23.INFO);
    addMode(MHPMCOUNTER24.INFO);
    addMode(MHPMCOUNTER25.INFO);
    addMode(MHPMCOUNTER26.INFO);
    addMode(MHPMCOUNTER27.INFO);
    addMode(MHPMCOUNTER28.INFO);
    addMode(MHPMCOUNTER29.INFO);
    addMode(MHPMCOUNTER30.INFO);
    addMode(MHPMCOUNTER31.INFO);
    addMode(MHPMEVENT3.INFO);
    addMode(MHPMEVENT4.INFO);
    addMode(MHPMEVENT5.INFO);
    addMode(MHPMEVENT6.INFO);
    addMode(MHPMEVENT7.INFO);
    addMode(MHPMEVENT8.INFO);
    addMode(MHPMEVENT9.INFO);
    addMode(MHPMEVENT10.INFO);
    addMode(MHPMEVENT11.INFO);
    addMode(MHPMEVENT12.INFO);
    addMode(MHPMEVENT13.INFO);
    addMode(MHPMEVENT14.INFO);
    addMode(MHPMEVENT15.INFO);
    addMode(MHPMEVENT16.INFO);
    addMode(MHPMEVENT17.INFO);
    addMode(MHPMEVENT18.INFO);
    addMode(MHPMEVENT19.INFO);
    addMode(MHPMEVENT20.INFO);
    addMode(MHPMEVENT21.INFO);
    addMode(MHPMEVENT22.INFO);
    addMode(MHPMEVENT23.INFO);
    addMode(MHPMEVENT24.INFO);
    addMode(MHPMEVENT25.INFO);
    addMode(MHPMEVENT26.INFO);
    addMode(MHPMEVENT27.INFO);
    addMode(MHPMEVENT28.INFO);
    addMode(MHPMEVENT29.INFO);
    addMode(MHPMEVENT30.INFO);
    addMode(MHPMEVENT31.INFO);
    addMode(TSELECT.INFO);
    addMode(TDATA1.INFO);
    addMode(TDATA2.INFO);
    addMode(TDATA3.INFO);
    addMode(DCSR.INFO);
    addMode(DPC.INFO);
    addMode(DSCRATCH.INFO);
    addMode(JUMP_IMM.INFO);
    addMode(JUMP_LABEL_JAL.INFO);
    addMode(BRANCH_LABEL.INFO);
    addMode(BRANCH_IMM.INFO);
    addMode(CX.INFO);
    addMode(CF.INFO);
    addMode(C_JUMP_IMM.INFO);
    addMode(C_JUMP_LABEL.INFO);
    addMode(C_BRANCH_IMM.INFO);
    addMode(C_BRANCH_LABEL_M2.INFO);
    addMode(VR.INFO);
    addMode(DELTA_LABEL.INFO);
    addMode(DELTA_IMM.INFO);

    addOperation(check_aligned.INFO);
    addOperation(load_data.INFO);
    addOperation(store_data.INFO);
    addOperation(process_float_exception_flags.INFO);
    addOperation(setSFRoundingMode.INFO);
    addOperation(setFPRoundingMode.INFO);
    addOperation(print_imm12.INFO);
    addOperation(flw.INFO);
    addOperation(fsw.INFO);
    addOperation(fadd_s.INFO);
    addOperation(fsub_s.INFO);
    addOperation(fmul_s.INFO);
    addOperation(fdiv_s.INFO);
    addOperation(fmin_s.INFO);
    addOperation(fmax_s.INFO);
    addOperation(fsqrt_s.INFO);
    addOperation(fsgnj_s.INFO);
    addOperation(fsgnjn_s.INFO);
    addOperation(fsgnjx_s.INFO);
    addOperation(fmadd_s.INFO);
    addOperation(fmsub_s.INFO);
    addOperation(fnmadd_s.INFO);
    addOperation(fnmsub_s.INFO);
    addOperation(fcvt_w_s.INFO);
    addOperation(fcvt_w_s2.INFO);
    addOperation(fcvt_wu_s.INFO);
    addOperation(fcvt_wu_s2.INFO);
    addOperation(fcvt_s_w.INFO);
    addOperation(fcvt_s_wu.INFO);
    addOperation(fmv_x_w.INFO);
    addOperation(fmv_w_x.INFO);
    addOperation(feq_s.INFO);
    addOperation(flt_s.INFO);
    addOperation(fle_s.INFO);
    addOperation(fclass_s.INFO);
    addOperation(fmv_s.INFO);
    addOperation(fabs_s.INFO);
    addOperation(fneg_s.INFO);
    addOperation(fmv_x_s.INFO);
    addOperation(fmv_s_x.INFO);
    addOperation(fld.INFO);
    addOperation(fsd.INFO);
    addOperation(fadd_d.INFO);
    addOperation(fsub_d.INFO);
    addOperation(fmul_d.INFO);
    addOperation(fdiv_d.INFO);
    addOperation(fmin_d.INFO);
    addOperation(fmax_d.INFO);
    addOperation(fsqrt_d.INFO);
    addOperation(fsgnj_d.INFO);
    addOperation(fsgnjn_d.INFO);
    addOperation(fsgnjx_d.INFO);
    addOperation(fmadd_d.INFO);
    addOperation(fmsub_d.INFO);
    addOperation(fnmadd_d.INFO);
    addOperation(fnmsub_d.INFO);
    addOperation(fcvt_w_d.INFO);
    addOperation(fcvt_w_d2.INFO);
    addOperation(fcvt_wu_d.INFO);
    addOperation(fcvt_wu_d2.INFO);
    addOperation(fcvt_d_w.INFO);
    addOperation(fcvt_d_wu.INFO);
    addOperation(fcvt_s_d.INFO);
    addOperation(fcvt_d_s.INFO);
    addOperation(feq_d.INFO);
    addOperation(flt_d.INFO);
    addOperation(fle_d.INFO);
    addOperation(fclass_d.INFO);
    addOperation(fmv_d.INFO);
    addOperation(fabs_d.INFO);
    addOperation(fneg_d.INFO);
    addOperation(lwu.INFO);
    addOperation(ld.INFO);
    addOperation(sd.INFO);
    addOperation(addiw.INFO);
    addOperation(slliw.INFO);
    addOperation(srliw.INFO);
    addOperation(sraiw.INFO);
    addOperation(addw.INFO);
    addOperation(subw.INFO);
    addOperation(sllw.INFO);
    addOperation(srlw.INFO);
    addOperation(sraw.INFO);
    addOperation(lui.INFO);
    addOperation(auipc.INFO);
    addOperation(jal.INFO);
    addOperation(jalr.INFO);
    addOperation(branch_image.INFO);
    addOperation(beq.INFO);
    addOperation(bne.INFO);
    addOperation(blt.INFO);
    addOperation(bltu.INFO);
    addOperation(bge.INFO);
    addOperation(bgeu.INFO);
    addOperation(lw.INFO);
    addOperation(lh.INFO);
    addOperation(lhu.INFO);
    addOperation(lb.INFO);
    addOperation(lbu.INFO);
    addOperation(sw.INFO);
    addOperation(sh.INFO);
    addOperation(sb.INFO);
    addOperation(addi.INFO);
    addOperation(slti.INFO);
    addOperation(sltiu.INFO);
    addOperation(xori.INFO);
    addOperation(ori.INFO);
    addOperation(andi.INFO);
    addOperation(slli.INFO);
    addOperation(srli.INFO);
    addOperation(srai.INFO);
    addOperation(sll.INFO);
    addOperation(srl.INFO);
    addOperation(sra.INFO);
    addOperation(add.INFO);
    addOperation(sub.INFO);
    addOperation(slt.INFO);
    addOperation(sltu.INFO);
    addOperation(and.INFO);
    addOperation(or.INFO);
    addOperation(xor.INFO);
    addOperation(nop.INFO);
    addOperation(mv.INFO);
    addOperation(not.INFO);
    addOperation(neg.INFO);
    addOperation(seqz.INFO);
    addOperation(snez.INFO);
    addOperation(sltz.INFO);
    addOperation(sgtz.INFO);
    addOperation(j.INFO);
    addOperation(jr.INFO);
    addOperation(beqz.INFO);
    addOperation(bnez.INFO);
    addOperation(blez.INFO);
    addOperation(bgez.INFO);
    addOperation(bltz.INFO);
    addOperation(bgtz.INFO);
    addOperation(c_addi4spn.INFO);
    addOperation(c_flw.INFO);
    addOperation(c_fld.INFO);
    addOperation(c_sw.INFO);
    addOperation(c_sd.INFO);
    addOperation(c_fsw.INFO);
    addOperation(c_fsd.INFO);
    addOperation(c_nop.INFO);
    addOperation(c_addi.INFO);
    addOperation(c_addiw.INFO);
    addOperation(c_addi16sp.INFO);
    addOperation(c_li.INFO);
    addOperation(c_lui.INFO);
    addOperation(c_srli.INFO);
    addOperation(c_srai.INFO);
    addOperation(c_lwsp.INFO);
    addOperation(c_ldsp.INFO);
    addOperation(c_swsp.INFO);
    addOperation(c_sdsp.INFO);
    addOperation(c_lw.INFO);
    addOperation(c_ld.INFO);
    addOperation(c_andi.INFO);
    addOperation(c_add.INFO);
    addOperation(c_or.INFO);
    addOperation(c_xor.INFO);
    addOperation(c_sub.INFO);
    addOperation(c_and.INFO);
    addOperation(c_addw.INFO);
    addOperation(c_subw.INFO);
    addOperation(c_j.INFO);
    addOperation(c_jal.INFO);
    addOperation(c_beqz.INFO);
    addOperation(c_bnez.INFO);
    addOperation(c_jr.INFO);
    addOperation(c_jalr.INFO);
    addOperation(c_slli.INFO);
    addOperation(c_flwsp.INFO);
    addOperation(c_fldsp.INFO);
    addOperation(c_mv.INFO);
    addOperation(c_ebreak.INFO);
    addOperation(c_fswsp.INFO);
    addOperation(c_fsdsp.INFO);
    addOperation(vadd.INFO);
    addOperation(vsub.INFO);
    addOperation(vsl.INFO);
    addOperation(vsr.INFO);
    addOperation(vand.INFO);
    addOperation(vor.INFO);
    addOperation(vxor.INFO);
    addOperation(vseq.INFO);
    addOperation(vsne.INFO);
    addOperation(vslt.INFO);
    addOperation(vsge.INFO);
    addOperation(vclip.INFO);
    addOperation(vcvt.INFO);
    addOperation(vmpop.INFO);
    addOperation(vmfirst.INFO);
    addOperation(vextract.INFO);
    addOperation(vinsert.INFO);
    addOperation(vmerge.INFO);
    addOperation(vselect.INFO);
    addOperation(vslide.INFO);
    addOperation(vdiv.INFO);
    addOperation(vrem.INFO);
    addOperation(vmul.INFO);
    addOperation(vmulh.INFO);
    addOperation(vmin.INFO);
    addOperation(vmax.INFO);
    addOperation(vsgnj.INFO);
    addOperation(vsgnjn.INFO);
    addOperation(vsgnjx.INFO);
    addOperation(vsqrt.INFO);
    addOperation(vclass.INFO);
    addOperation(vpopc.INFO);
    addOperation(vaddi.INFO);
    addOperation(vsli.INFO);
    addOperation(vsri.INFO);
    addOperation(vandi.INFO);
    addOperation(vori.INFO);
    addOperation(vxori.INFO);
    addOperation(vclipi.INFO);
    addOperation(vmadd.INFO);
    addOperation(vmsub.INFO);
    addOperation(vnmadd.INFO);
    addOperation(vnmsub.INFO);
    addOperation(vld.INFO);
    addOperation(vlds.INFO);
    addOperation(vldx.INFO);
    addOperation(vst.INFO);
    addOperation(vsts.INFO);
    addOperation(vstx.INFO);
    addOperation(vamoswap.INFO);
    addOperation(vamoadd.INFO);
    addOperation(vamoand.INFO);
    addOperation(vamoor.INFO);
    addOperation(vamoxor.INFO);
    addOperation(vamomin.INFO);
    addOperation(vamomax.INFO);
    addOperation(fcvt_l_d.INFO);
    addOperation(fcvt_l_d2.INFO);
    addOperation(fcvt_lu_d.INFO);
    addOperation(fcvt_lu_d2.INFO);
    addOperation(fcvt_d_l.INFO);
    addOperation(fcvt_d_lu.INFO);
    addOperation(fmv_x_d.INFO);
    addOperation(fmv_d_x.INFO);
    addOperation(fcvt_l_s.INFO);
    addOperation(fcvt_l_s2.INFO);
    addOperation(fcvt_lu_s.INFO);
    addOperation(fcvt_lu_s2.INFO);
    addOperation(fcvt_s_l.INFO);
    addOperation(fcvt_s_lu.INFO);
    addOperation(lr_d.INFO);
    addOperation(sc_d.INFO);
    addOperation(amoswap_d.INFO);
    addOperation(amoadd_d.INFO);
    addOperation(amoand_d.INFO);
    addOperation(amoor_d.INFO);
    addOperation(amoxor_d.INFO);
    addOperation(amomin_d.INFO);
    addOperation(amomax_d.INFO);
    addOperation(amominu_d.INFO);
    addOperation(amomaxu_d.INFO);
    addOperation(mulw.INFO);
    addOperation(divw.INFO);
    addOperation(divuw.INFO);
    addOperation(remw.INFO);
    addOperation(remuw.INFO);
    addOperation(lr_w.INFO);
    addOperation(sc_w.INFO);
    addOperation(amoswap_w.INFO);
    addOperation(amoadd_w.INFO);
    addOperation(amoand_w.INFO);
    addOperation(amoor_w.INFO);
    addOperation(amoxor_w.INFO);
    addOperation(amomin_w.INFO);
    addOperation(amomax_w.INFO);
    addOperation(amominu_w.INFO);
    addOperation(amomaxu_w.INFO);
    addOperation(mul.INFO);
    addOperation(mulh.INFO);
    addOperation(mulhu.INFO);
    addOperation(mulhsu.INFO);
    addOperation(div.INFO);
    addOperation(divu.INFO);
    addOperation(rem.INFO);
    addOperation(remu.INFO);
    addOperation(ecall.INFO);
    addOperation(ebreak.INFO);
    addOperation(fence.INFO);
    addOperation(fence_i.INFO);
    addOperation(xret.INFO);
    addOperation(mret.INFO);
    addOperation(sret.INFO);
    addOperation(uret.INFO);
    addOperation(wfi.INFO);
    addOperation(csrrw.INFO);
    addOperation(csrrs.INFO);
    addOperation(csrrc.INFO);
    addOperation(csrrwi.INFO);
    addOperation(csrrsi.INFO);
    addOperation(csrrci.INFO);
    addOperation(csrw.INFO);
    addOperation(csrr.INFO);
    addOperation(csrs.INFO);
    addOperation(csrc.INFO);
    addOperation(csrwi.INFO);
    addOperation(csrsi.INFO);
    addOperation(csrci.INFO);
    addOperation(frcsr.INFO);
    addOperation(fscsr.INFO);
    addOperation(fscsr2.INFO);
    addOperation(frrm.INFO);
    addOperation(fsrm.INFO);
    addOperation(fsrm2.INFO);
    addOperation(fsrmi.INFO);
    addOperation(fsrmi2.INFO);
    addOperation(frflags.INFO);
    addOperation(fsflags.INFO);
    addOperation(fsflags2.INFO);
    addOperation(fsflagsi.INFO);
    addOperation(fsflagsi2.INFO);
    addOperation(rdinstret.INFO);
    addOperation(rdcycle.INFO);
    addOperation(rdtime.INFO);
    addOperation(instruction.INFO);
    addOperation(instruction16.INFO);
    addOperation(exception.INFO);
    addOperation(la.INFO);
    addOperation(lla.INFO);
    addOperation(lb_global.INFO);
    addOperation(lh_global.INFO);
    addOperation(lh_global2.INFO);
    addOperation(lw_global.INFO);
    addOperation(ld_global.INFO);
    addOperation(sb_global.INFO);
    addOperation(sh_global.INFO);
    addOperation(sh_global2.INFO);
    addOperation(sw_global.INFO);
    addOperation(sd_global.INFO);
    addOperation(li32.INFO);
    addOperation(li64.INFO);
    addOperation(li.INFO);
    addOperation(flw_global.INFO);
    addOperation(fld_global.INFO);
    addOperation(fsw_global.INFO);
    addOperation(fsd_global.INFO);
    addOperation(call.INFO);
    addOperation(tail.INFO);
    addOperation(ret.INFO);
  }
}
