/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv;

import java.math.BigInteger;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.memory.Label;
import ru.ispras.microtesk.model.memory.Memory;

/**
 * The {@code PE} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class PE extends ProcessingElement {
  public final Memory XREG;
  public final Memory FPR;
  public final Memory PC;
  public final Memory CSR;
  public final Memory MEM;
  public final Memory LOAD_RESERVATION;
  public final Memory FFLAGS_CSR;
  public final Memory FFLAGS_EXCEP;
  public final Memory FRM_CSR;
  public final Memory FRM_FRM;
  public final Memory FCSR_CSR;
  public final Memory FCSR_EXCEP;
  public final Memory FCSR_NX;
  public final Memory FCSR_UF;
  public final Memory FCSR_OF;
  public final Memory FCSR_DZ;
  public final Memory FCSR_NV;
  public final Memory FCSR_FRM;
  public final Memory VREG;

  private PE() {
    super();
    this.XREG = Memory.def(Memory.Kind.REG, "XREG", TypeDefs.XWORD, 32);
    this.FPR = Memory.def(Memory.Kind.REG, "FPR", Type.CARD(64), 32);
    this.PC = Memory.def(Memory.Kind.REG, "PC", TypeDefs.XWORD, 1);
    this.CSR = Memory.def(Memory.Kind.REG, "CSR", TypeDefs.CSR_TYPE, 0x1000);
    this.MEM = Memory.def(Memory.Kind.MEM, "MEM", TypeDefs.WORD, 0x4000000000000000L);
    this.LOAD_RESERVATION = Memory.def(Memory.Kind.REG, "LOAD_RESERVATION", TypeDefs.XWORD, 1);
    this.FFLAGS_CSR = Memory.def(Memory.Kind.REG, "FFLAGS_CSR", TypeDefs.CSR_TYPE, 1, CSR.access(1));
    this.FFLAGS_EXCEP = Memory.def(Memory.Kind.REG, "FFLAGS_EXCEP", Type.CARD(5), 1, FFLAGS_CSR.access().bitField(4, 0));
    this.FRM_CSR = Memory.def(Memory.Kind.REG, "FRM_CSR", TypeDefs.CSR_TYPE, 1, CSR.access(2));
    this.FRM_FRM = Memory.def(Memory.Kind.REG, "FRM_FRM", Type.CARD(3), 1, FRM_CSR.access().bitField(2, 0));
    this.FCSR_CSR = Memory.def(Memory.Kind.REG, "FCSR_CSR", TypeDefs.CSR_TYPE, 1, CSR.access(3));
    this.FCSR_EXCEP = Memory.def(Memory.Kind.REG, "FCSR_EXCEP", Type.CARD(5), 1, FCSR_CSR.access().bitField(4, 0));
    this.FCSR_NX = Memory.def(Memory.Kind.REG, "FCSR_NX", TypeDefs.BIT, 1, FCSR_CSR.access().bitField(0, 0));
    this.FCSR_UF = Memory.def(Memory.Kind.REG, "FCSR_UF", TypeDefs.BIT, 1, FCSR_CSR.access().bitField(1, 1));
    this.FCSR_OF = Memory.def(Memory.Kind.REG, "FCSR_OF", TypeDefs.BIT, 1, FCSR_CSR.access().bitField(2, 2));
    this.FCSR_DZ = Memory.def(Memory.Kind.REG, "FCSR_DZ", TypeDefs.BIT, 1, FCSR_CSR.access().bitField(3, 3));
    this.FCSR_NV = Memory.def(Memory.Kind.REG, "FCSR_NV", TypeDefs.BIT, 1, FCSR_CSR.access().bitField(4, 4));
    this.FCSR_FRM = Memory.def(Memory.Kind.REG, "FCSR_FRM", Type.CARD(3), 1, FCSR_CSR.access().bitField(7, 5));
    this.VREG = Memory.def(Memory.Kind.REG, "VREG", TypeDefs.HWORD, 32);

    registerAll();
  }

  private PE(final PE other, final boolean shared) {
    super(other);
    this.XREG = other.XREG.copy();
    this.FPR = other.FPR.copy();
    this.PC = other.PC.copy();
    this.CSR = other.CSR.copy();
    this.MEM = shared ? other.MEM : other.MEM.copy();
    this.LOAD_RESERVATION = other.LOAD_RESERVATION.copy();
    this.FFLAGS_CSR = Memory.def(Memory.Kind.REG, "FFLAGS_CSR", TypeDefs.CSR_TYPE, 1, CSR.access(1));
    this.FFLAGS_EXCEP = Memory.def(Memory.Kind.REG, "FFLAGS_EXCEP", Type.CARD(5), 1, FFLAGS_CSR.access().bitField(4, 0));
    this.FRM_CSR = Memory.def(Memory.Kind.REG, "FRM_CSR", TypeDefs.CSR_TYPE, 1, CSR.access(2));
    this.FRM_FRM = Memory.def(Memory.Kind.REG, "FRM_FRM", Type.CARD(3), 1, FRM_CSR.access().bitField(2, 0));
    this.FCSR_CSR = Memory.def(Memory.Kind.REG, "FCSR_CSR", TypeDefs.CSR_TYPE, 1, CSR.access(3));
    this.FCSR_EXCEP = Memory.def(Memory.Kind.REG, "FCSR_EXCEP", Type.CARD(5), 1, FCSR_CSR.access().bitField(4, 0));
    this.FCSR_NX = Memory.def(Memory.Kind.REG, "FCSR_NX", TypeDefs.BIT, 1, FCSR_CSR.access().bitField(0, 0));
    this.FCSR_UF = Memory.def(Memory.Kind.REG, "FCSR_UF", TypeDefs.BIT, 1, FCSR_CSR.access().bitField(1, 1));
    this.FCSR_OF = Memory.def(Memory.Kind.REG, "FCSR_OF", TypeDefs.BIT, 1, FCSR_CSR.access().bitField(2, 2));
    this.FCSR_DZ = Memory.def(Memory.Kind.REG, "FCSR_DZ", TypeDefs.BIT, 1, FCSR_CSR.access().bitField(3, 3));
    this.FCSR_NV = Memory.def(Memory.Kind.REG, "FCSR_NV", TypeDefs.BIT, 1, FCSR_CSR.access().bitField(4, 4));
    this.FCSR_FRM = Memory.def(Memory.Kind.REG, "FCSR_FRM", Type.CARD(3), 1, FCSR_CSR.access().bitField(7, 5));
    this.VREG = other.VREG.copy();

    registerAll();
  }

  private void registerAll() {
    addStorage(XREG);
    addStorage(FPR);
    addStorage(PC);
    addStorage(CSR);
    addStorage(MEM);
    addStorage(LOAD_RESERVATION);
    addStorage(FFLAGS_CSR);
    addStorage(FFLAGS_EXCEP);
    addStorage(FRM_CSR);
    addStorage(FRM_FRM);
    addStorage(FCSR_CSR);
    addStorage(FCSR_EXCEP);
    addStorage(FCSR_NX);
    addStorage(FCSR_UF);
    addStorage(FCSR_OF);
    addStorage(FCSR_DZ);
    addStorage(FCSR_NV);
    addStorage(FCSR_FRM);
    addStorage(VREG);
  }

  @Override
  public ProcessingElement copy(final boolean shared) {
    return new PE(this, shared);
  }

  private static final class PEFactory implements Factory {
    @Override
    public PE create() {
      return new PE();
    }
  }

  public static Factory newFactory() {
    return new PEFactory();
  }
}
