/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.decoder;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.mode.C_BRANCH_IMM;
import ru.ispras.microtesk.model.Immediate;

/**
 * The {@code DecoderC_BRANCH_IMM} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderC_BRANCH_IMM extends DecoderItem {
  private static DecoderC_BRANCH_IMM instance = null;

  public static DecoderC_BRANCH_IMM get() {
    if (null == instance) {
      instance = new DecoderC_BRANCH_IMM();
    }
    return instance;
  }

  private DecoderC_BRANCH_IMM() {
    super(
        8,
        true,
        null,
        null
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    Immediate imm = null;

    imm = readNextImmediate(image, Type.CARD(8));

    return newResult(new C_BRANCH_IMM(imm));
  }
}
