/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.decoder;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.op.c_addi16sp;
import ru.ispras.microtesk.model.Immediate;
import ru.ispras.microtesk.model.riscv.mode.X;

/**
 * The {@code DecoderC_addi16sp} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderC_addi16sp extends DecoderItem {
  private static DecoderC_addi16sp instance = null;

  public static DecoderC_addi16sp get() {
    if (null == instance) {
      instance = new DecoderC_addi16sp();
    }
    return instance;
  }

  private DecoderC_addi16sp() {
    super(
        16,
        true,
        "0110000100000001",
        "1110111110000011"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    Immediate nzimm = null;

    if (!matchNextOpc(image, BitVector.valueOf("011", 2, 3))) {
      return null;
    }
    nzimm = new Immediate(Type.INT(10));
    nzimm.access().bitField(9, 9).store(readNextImmediate(image, Type.INT(1)).access());
    final X X_instance;
    X_instance = (X) readNextPrimitive(image, DecoderX.get());
    if (null == X_instance) {
      return null;
    }
    nzimm.access().bitField(4, 4).store(readNextImmediate(image, Type.INT(1)).access());
    nzimm.access().bitField(6, 6).store(readNextImmediate(image, Type.INT(1)).access());
    nzimm.access().bitField(8, 7).store(readNextImmediate(image, Type.INT(2)).access());
    nzimm.access().bitField(5, 5).store(readNextImmediate(image, Type.INT(1)).access());
    if (!matchNextOpc(image, BitVector.valueOf("01", 2, 2))) {
      return null;
    }

    return newResult(new c_addi16sp(nzimm));
  }
}
