/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.decoder;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.op.c_addi4spn;
import ru.ispras.microtesk.model.riscv.mode.CX;
import ru.ispras.microtesk.model.Immediate;

/**
 * The {@code DecoderC_addi4spn} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderC_addi4spn extends DecoderItem {
  private static DecoderC_addi4spn instance = null;

  public static DecoderC_addi4spn get() {
    if (null == instance) {
      instance = new DecoderC_addi4spn();
    }
    return instance;
  }

  private DecoderC_addi4spn() {
    super(
        16,
        true,
        "0000000000000000",
        "1110000000000011"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    CX rd = null;
    Immediate nzuimm = null;

    if (!matchNextOpc(image, BitVector.valueOf("000", 2, 3))) {
      return null;
    }
    nzuimm = new Immediate(Type.CARD(10));
    nzuimm.access().bitField(5, 4).store(readNextImmediate(image, Type.CARD(2)).access());
    nzuimm.access().bitField(9, 6).store(readNextImmediate(image, Type.CARD(4)).access());
    nzuimm.access().bitField(2, 2).store(readNextImmediate(image, Type.CARD(1)).access());
    nzuimm.access().bitField(3, 3).store(readNextImmediate(image, Type.CARD(1)).access());
    rd = (CX) readNextPrimitive(image, DecoderCX.get());
    if (null == rd) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("00", 2, 2))) {
      return null;
    }

    return newResult(new c_addi4spn(rd, nzuimm));
  }
}
