/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.decoder;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.op.c_beqz;
import ru.ispras.microtesk.model.riscv.mode.CX;
import ru.ispras.microtesk.model.IsaPrimitive;
import ru.ispras.microtesk.model.Immediate;

/**
 * The {@code DecoderC_beqz} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderC_beqz extends DecoderItem {
  private static DecoderC_beqz instance = null;

  public static DecoderC_beqz get() {
    if (null == instance) {
      instance = new DecoderC_beqz();
    }
    return instance;
  }

  private DecoderC_beqz() {
    super(
        16,
        true,
        "1100000000000001",
        "1110000000000011"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    CX rs1 = null;
    IsaPrimitive offset = null;

    if (!matchNextOpc(image, BitVector.valueOf("110", 2, 3))) {
      return null;
    }
    offset = new Immediate(Type.CARD(8));
    offset.access().bitField(7, 7).store(readNextImmediate(image, Type.CARD(1)).access());
    offset.access().bitField(3, 2).store(readNextImmediate(image, Type.CARD(2)).access());
    rs1 = (CX) readNextPrimitive(image, DecoderCX.get());
    if (null == rs1) {
      return null;
    }
    offset.access().bitField(6, 5).store(readNextImmediate(image, Type.CARD(2)).access());
    offset.access().bitField(1, 0).store(readNextImmediate(image, Type.CARD(2)).access());
    offset.access().bitField(4, 4).store(readNextImmediate(image, Type.CARD(1)).access());
    if (!matchNextOpc(image, BitVector.valueOf("01", 2, 2))) {
      return null;
    }
    resetPosition();
    offset = (IsaPrimitive) readNextPrimitive(offset.access().load().getRawData(), DecoderC_BRANCH_OFFSET_M2.get());
    if (null == offset) {
      return null;
    }

    return newResult(new c_beqz(rs1, offset));
  }
}
