/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.decoder;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.op.c_fsd;
import ru.ispras.microtesk.model.riscv.mode.CF;
import ru.ispras.microtesk.model.riscv.mode.CX;
import ru.ispras.microtesk.model.Immediate;

/**
 * The {@code DecoderC_fsd} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderC_fsd extends DecoderItem {
  private static DecoderC_fsd instance = null;

  public static DecoderC_fsd get() {
    if (null == instance) {
      instance = new DecoderC_fsd();
    }
    return instance;
  }

  private DecoderC_fsd() {
    super(
        16,
        true,
        "1010000000000000",
        "1110000000000011"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    CF rs2 = null;
    CX rs1 = null;
    Immediate offset = null;

    if (!matchNextOpc(image, BitVector.valueOf("101", 2, 3))) {
      return null;
    }
    offset = new Immediate(Type.CARD(8));
    offset.access().bitField(5, 3).store(readNextImmediate(image, Type.CARD(3)).access());
    rs1 = (CX) readNextPrimitive(image, DecoderCX.get());
    if (null == rs1) {
      return null;
    }
    offset.access().bitField(7, 6).store(readNextImmediate(image, Type.CARD(2)).access());
    rs2 = (CF) readNextPrimitive(image, DecoderCF.get());
    if (null == rs2) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("00", 2, 2))) {
      return null;
    }

    return newResult(new c_fsd(rs2, rs1, offset));
  }
}
