/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.decoder;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.op.c_srli;
import ru.ispras.microtesk.model.riscv.mode.CX;
import ru.ispras.microtesk.model.Immediate;

/**
 * The {@code DecoderC_srli} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderC_srli extends DecoderItem {
  private static DecoderC_srli instance = null;

  public static DecoderC_srli get() {
    if (null == instance) {
      instance = new DecoderC_srli();
    }
    return instance;
  }

  private DecoderC_srli() {
    super(
        16,
        true,
        "1000000000000001",
        "1110110000000011"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    CX rd = null;
    Immediate shamt = null;

    if (!matchNextOpc(image, BitVector.valueOf("100", 2, 3))) {
      return null;
    }
    shamt = new Immediate(Type.CARD(6));
    shamt.access().bitField(5, 5).store(readNextImmediate(image, Type.CARD(1)).access());
    if (!matchNextOpc(image, BitVector.valueOf("00", 2, 2))) {
      return null;
    }
    rd = (CX) readNextPrimitive(image, DecoderCX.get());
    if (null == rd) {
      return null;
    }
    shamt.access().bitField(4, 0).store(readNextImmediate(image, Type.CARD(5)).access());
    if (!matchNextOpc(image, BitVector.valueOf("01", 2, 2))) {
      return null;
    }

    return newResult(new c_srli(rd, shamt));
  }
}
