/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.decoder;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.op.c_sub;
import ru.ispras.microtesk.model.riscv.mode.CX;

/**
 * The {@code DecoderC_sub} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderC_sub extends DecoderItem {
  private static DecoderC_sub instance = null;

  public static DecoderC_sub get() {
    if (null == instance) {
      instance = new DecoderC_sub();
    }
    return instance;
  }

  private DecoderC_sub() {
    super(
        16,
        true,
        "1000110000000001",
        "1111110001100011"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    CX rd = null;
    CX rs2 = null;

    if (!matchNextOpc(image, BitVector.valueOf("100011", 2, 6))) {
      return null;
    }
    rd = (CX) readNextPrimitive(image, DecoderCX.get());
    if (null == rd) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("00", 2, 2))) {
      return null;
    }
    rs2 = (CX) readNextPrimitive(image, DecoderCX.get());
    if (null == rs2) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("01", 2, 2))) {
      return null;
    }

    return newResult(new c_sub(rd, rs2));
  }
}
