/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.decoder;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.op.flw;
import ru.ispras.microtesk.model.riscv.mode.F;
import ru.ispras.microtesk.model.riscv.mode.X;
import ru.ispras.microtesk.model.Immediate;

/**
 * The {@code DecoderFlw} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderFlw extends DecoderItem {
  private static DecoderFlw instance = null;

  public static DecoderFlw get() {
    if (null == instance) {
      instance = new DecoderFlw();
    }
    return instance;
  }

  private DecoderFlw() {
    super(
        32,
        true,
        "00000000000000000010000000000111",
        "00000000000000000111000001111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    F rd = null;
    X rs1 = null;
    Immediate imm = null;

    imm = readNextImmediate(image, Type.CARD(12));
    rs1 = (X) readNextPrimitive(image, DecoderX.get());
    if (null == rs1) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("010", 2, 3))) {
      return null;
    }
    rd = (F) readNextPrimitive(image, DecoderF.get());
    if (null == rd) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("0000111", 2, 7))) {
      return null;
    }

    return newResult(new flw(rd, rs1, imm));
  }
}
