/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.decoder;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.mode.JUMP_IMM;
import ru.ispras.microtesk.model.Immediate;

/**
 * The {@code DecoderJUMP_IMM} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderJUMP_IMM extends DecoderItem {
  private static DecoderJUMP_IMM instance = null;

  public static DecoderJUMP_IMM get() {
    if (null == instance) {
      instance = new DecoderJUMP_IMM();
    }
    return instance;
  }

  private DecoderJUMP_IMM() {
    super(
        20,
        true,
        null,
        null
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    Immediate imm = null;

    imm = new Immediate(Type.INT(20));
    imm.access().bitField(19, 19).store(readNextImmediate(image, Type.INT(1)).access());
    imm.access().bitField(9, 0).store(readNextImmediate(image, Type.INT(10)).access());
    imm.access().bitField(10, 10).store(readNextImmediate(image, Type.INT(1)).access());
    imm.access().bitField(18, 11).store(readNextImmediate(image, Type.INT(8)).access());

    return newResult(new JUMP_IMM(imm));
  }
}
