/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.decoder;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.op.vamomin;
import ru.ispras.microtesk.model.riscv.mode.VR;

/**
 * The {@code DecoderVamomin} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderVamomin extends DecoderItem {
  private static DecoderVamomin instance = null;

  public static DecoderVamomin get() {
    if (null == instance) {
      instance = new DecoderVamomin();
    }
    return instance;
  }

  private DecoderVamomin() {
    super(
        32,
        true,
        "00000110000010000100000000100111",
        "00000110000011111111000001111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    VR vd = null;
    VR vs2 = null;
    VR vs3 = null;

    vs3 = (VR) readNextPrimitive(image, DecoderVR.get());
    if (null == vs3) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("11", 2, 2))) {
      return null;
    }
    vs2 = (VR) readNextPrimitive(image, DecoderVR.get());
    if (null == vs2) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("10000", 2, 5))) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("1", 2, 1))) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("00", 2, 2))) {
      return null;
    }
    vd = (VR) readNextPrimitive(image, DecoderVR.get());
    if (null == vd) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("0100111", 2, 7))) {
      return null;
    }

    return newResult(new vamomin(vd, vs2, vs3));
  }
}
