/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.decoder;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.op.vextract;
import ru.ispras.microtesk.model.riscv.mode.X;
import ru.ispras.microtesk.model.riscv.mode.VR;

/**
 * The {@code DecoderVextract} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderVextract extends DecoderItem {
  private static DecoderVextract instance = null;

  public static DecoderVextract get() {
    if (null == instance) {
      instance = new DecoderVextract();
    }
    return instance;
  }

  private DecoderVextract() {
    super(
        32,
        true,
        "10100000000000000100000001100111",
        "11111110000000000111000001111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    X rd = null;
    VR vs1 = null;
    X rs2 = null;

    if (!matchNextOpc(image, BitVector.valueOf("1010", 2, 4))) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("000", 2, 3))) {
      return null;
    }
    rs2 = (X) readNextPrimitive(image, DecoderX.get());
    if (null == rs2) {
      return null;
    }
    vs1 = (VR) readNextPrimitive(image, DecoderVR.get());
    if (null == vs1) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("1", 2, 1))) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("00", 2, 2))) {
      return null;
    }
    rd = (X) readNextPrimitive(image, DecoderX.get());
    if (null == rd) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("1100111", 2, 7))) {
      return null;
    }

    return newResult(new vextract(rd, vs1, rs2));
  }
}
