/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.decoder;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.op.vldx;
import ru.ispras.microtesk.model.riscv.mode.VR;
import ru.ispras.microtesk.model.riscv.mode.X;
import ru.ispras.microtesk.model.Immediate;

/**
 * The {@code DecoderVldx} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderVldx extends DecoderItem {
  private static DecoderVldx instance = null;

  public static DecoderVldx get() {
    if (null == instance) {
      instance = new DecoderVldx();
    }
    return instance;
  }

  private DecoderVldx() {
    super(
        32,
        true,
        "00000100000000000100000000000111",
        "00000110000000000111000001111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    VR vd = null;
    X rs1 = null;
    VR vs2 = null;
    Immediate imm = null;

    imm = readNextImmediate(image, Type.CARD(5));
    if (!matchNextOpc(image, BitVector.valueOf("10", 2, 2))) {
      return null;
    }
    vs2 = (VR) readNextPrimitive(image, DecoderVR.get());
    if (null == vs2) {
      return null;
    }
    rs1 = (X) readNextPrimitive(image, DecoderX.get());
    if (null == rs1) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("1", 2, 1))) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("00", 2, 2))) {
      return null;
    }
    vd = (VR) readNextPrimitive(image, DecoderVR.get());
    if (null == vd) {
      return null;
    }
    if (!matchNextOpc(image, BitVector.valueOf("0000111", 2, 7))) {
      return null;
    }

    return newResult(new vldx(vd, rs1, vs2, imm));
  }
}
