/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.metadata;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

import java.math.BigInteger;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.metadata.MetaModel;
import ru.ispras.microtesk.model.metadata.MetaModelBuilder;

/**
 * The {@code MetaModelFactory} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class MetaModelFactory {
  private MetaModelFactory() {}

  public static MetaModel newMetaModel() {
    final MetaModelBuilder builder = new MetaModelBuilder();

    builder.addRegister("XREG", XWORD, 32);
    builder.addRegister("FPR", Type.CARD(64), 32);
    builder.addRegister("PC", XWORD, 1);
    builder.addRegister("CSR", CSR_TYPE, 4096);
    builder.addRegister("LOAD_RESERVATION", XWORD, 1);
    builder.addRegister("FFLAGS_CSR", CSR_TYPE, 1);
    builder.addRegister("FFLAGS_EXCEP", Type.CARD(5), 1);
    builder.addRegister("FRM_CSR", CSR_TYPE, 1);
    builder.addRegister("FRM_FRM", Type.CARD(3), 1);
    builder.addRegister("FCSR_CSR", CSR_TYPE, 1);
    builder.addRegister("FCSR_EXCEP", Type.CARD(5), 1);
    builder.addRegister("FCSR_NX", BIT, 1);
    builder.addRegister("FCSR_UF", BIT, 1);
    builder.addRegister("FCSR_OF", BIT, 1);
    builder.addRegister("FCSR_DZ", BIT, 1);
    builder.addRegister("FCSR_NV", BIT, 1);
    builder.addRegister("FCSR_FRM", Type.CARD(3), 1);
    builder.addRegister("VREG", HWORD, 32);

    builder.addMemory("MEM", WORD, 0x4000000000000000L);

    builder.addMode(ZERO.get());
    builder.addMode(RA.get());
    builder.addMode(SP.get());
    builder.addMode(GP.get());
    builder.addMode(TP.get());
    builder.addMode(TemporariesCaller.get());
    builder.addMode(SavedCallee.get());
    builder.addMode(FunctionCaller.get());
    builder.addMode(X.get());
    builder.addMode(FPTemporariesCaller.get());
    builder.addMode(FPSavedCallee.get());
    builder.addMode(FPArgumentsCaller.get());
    builder.addMode(F.get());
    builder.addMode(USTATUS.get());
    builder.addMode(UIE.get());
    builder.addMode(UTVEC.get());
    builder.addMode(USCRATCH.get());
    builder.addMode(UEPC.get());
    builder.addMode(UCAUSE.get());
    builder.addMode(UTVAL.get());
    builder.addMode(UIP.get());
    builder.addMode(FFLAGS.get());
    builder.addMode(FRM.get());
    builder.addMode(FCSR.get());
    builder.addMode(CYCLE.get());
    builder.addMode(TIME.get());
    builder.addMode(INSTRET.get());
    builder.addMode(HPMCOUNTER3.get());
    builder.addMode(HPMCOUNTER4.get());
    builder.addMode(HPMCOUNTER5.get());
    builder.addMode(HPMCOUNTER6.get());
    builder.addMode(HPMCOUNTER7.get());
    builder.addMode(HPMCOUNTER8.get());
    builder.addMode(HPMCOUNTER9.get());
    builder.addMode(HPMCOUNTER10.get());
    builder.addMode(HPMCOUNTER11.get());
    builder.addMode(HPMCOUNTER12.get());
    builder.addMode(HPMCOUNTER13.get());
    builder.addMode(HPMCOUNTER14.get());
    builder.addMode(HPMCOUNTER15.get());
    builder.addMode(HPMCOUNTER16.get());
    builder.addMode(HPMCOUNTER17.get());
    builder.addMode(HPMCOUNTER18.get());
    builder.addMode(HPMCOUNTER19.get());
    builder.addMode(HPMCOUNTER20.get());
    builder.addMode(HPMCOUNTER21.get());
    builder.addMode(HPMCOUNTER22.get());
    builder.addMode(HPMCOUNTER23.get());
    builder.addMode(HPMCOUNTER24.get());
    builder.addMode(HPMCOUNTER25.get());
    builder.addMode(HPMCOUNTER26.get());
    builder.addMode(HPMCOUNTER27.get());
    builder.addMode(HPMCOUNTER28.get());
    builder.addMode(HPMCOUNTER29.get());
    builder.addMode(HPMCOUNTER30.get());
    builder.addMode(HPMCOUNTER31.get());
    builder.addMode(SSTATUS.get());
    builder.addMode(SEDELEG.get());
    builder.addMode(SIDELEG.get());
    builder.addMode(SIE.get());
    builder.addMode(STVEC.get());
    builder.addMode(SCOUNTEREN.get());
    builder.addMode(SSCRATCH.get());
    builder.addMode(SEPC.get());
    builder.addMode(SCAUSE.get());
    builder.addMode(STVAL.get());
    builder.addMode(SIP.get());
    builder.addMode(SATP.get());
    builder.addMode(MVENDORID.get());
    builder.addMode(MARCHID.get());
    builder.addMode(MIMPID.get());
    builder.addMode(MHARTID.get());
    builder.addMode(MSTATUS.get());
    builder.addMode(MISA.get());
    builder.addMode(MEDELEG.get());
    builder.addMode(MIDELEG.get());
    builder.addMode(MIE.get());
    builder.addMode(MTVEC.get());
    builder.addMode(MCOUNTEREN.get());
    builder.addMode(MSCRATCH.get());
    builder.addMode(MEPC.get());
    builder.addMode(MCAUSE.get());
    builder.addMode(MTVAL.get());
    builder.addMode(MIP.get());
    builder.addMode(PMPCFG0.get());
    builder.addMode(PMPCFG1.get());
    builder.addMode(PMPCFG2.get());
    builder.addMode(PMPCFG3.get());
    builder.addMode(PMPADDR0.get());
    builder.addMode(PMPADDR1.get());
    builder.addMode(PMPADDR2.get());
    builder.addMode(PMPADDR3.get());
    builder.addMode(PMPADDR4.get());
    builder.addMode(PMPADDR5.get());
    builder.addMode(PMPADDR6.get());
    builder.addMode(PMPADDR7.get());
    builder.addMode(PMPADDR8.get());
    builder.addMode(PMPADDR9.get());
    builder.addMode(PMPADDR10.get());
    builder.addMode(PMPADDR11.get());
    builder.addMode(PMPADDR12.get());
    builder.addMode(PMPADDR13.get());
    builder.addMode(PMPADDR14.get());
    builder.addMode(PMPADDR15.get());
    builder.addMode(MCYCLE.get());
    builder.addMode(MINSTRET.get());
    builder.addMode(MHPMCOUNTER3.get());
    builder.addMode(MHPMCOUNTER4.get());
    builder.addMode(MHPMCOUNTER5.get());
    builder.addMode(MHPMCOUNTER6.get());
    builder.addMode(MHPMCOUNTER7.get());
    builder.addMode(MHPMCOUNTER8.get());
    builder.addMode(MHPMCOUNTER9.get());
    builder.addMode(MHPMCOUNTER10.get());
    builder.addMode(MHPMCOUNTER11.get());
    builder.addMode(MHPMCOUNTER12.get());
    builder.addMode(MHPMCOUNTER13.get());
    builder.addMode(MHPMCOUNTER14.get());
    builder.addMode(MHPMCOUNTER15.get());
    builder.addMode(MHPMCOUNTER16.get());
    builder.addMode(MHPMCOUNTER17.get());
    builder.addMode(MHPMCOUNTER18.get());
    builder.addMode(MHPMCOUNTER19.get());
    builder.addMode(MHPMCOUNTER20.get());
    builder.addMode(MHPMCOUNTER21.get());
    builder.addMode(MHPMCOUNTER22.get());
    builder.addMode(MHPMCOUNTER23.get());
    builder.addMode(MHPMCOUNTER24.get());
    builder.addMode(MHPMCOUNTER25.get());
    builder.addMode(MHPMCOUNTER26.get());
    builder.addMode(MHPMCOUNTER27.get());
    builder.addMode(MHPMCOUNTER28.get());
    builder.addMode(MHPMCOUNTER29.get());
    builder.addMode(MHPMCOUNTER30.get());
    builder.addMode(MHPMCOUNTER31.get());
    builder.addMode(MHPMEVENT3.get());
    builder.addMode(MHPMEVENT4.get());
    builder.addMode(MHPMEVENT5.get());
    builder.addMode(MHPMEVENT6.get());
    builder.addMode(MHPMEVENT7.get());
    builder.addMode(MHPMEVENT8.get());
    builder.addMode(MHPMEVENT9.get());
    builder.addMode(MHPMEVENT10.get());
    builder.addMode(MHPMEVENT11.get());
    builder.addMode(MHPMEVENT12.get());
    builder.addMode(MHPMEVENT13.get());
    builder.addMode(MHPMEVENT14.get());
    builder.addMode(MHPMEVENT15.get());
    builder.addMode(MHPMEVENT16.get());
    builder.addMode(MHPMEVENT17.get());
    builder.addMode(MHPMEVENT18.get());
    builder.addMode(MHPMEVENT19.get());
    builder.addMode(MHPMEVENT20.get());
    builder.addMode(MHPMEVENT21.get());
    builder.addMode(MHPMEVENT22.get());
    builder.addMode(MHPMEVENT23.get());
    builder.addMode(MHPMEVENT24.get());
    builder.addMode(MHPMEVENT25.get());
    builder.addMode(MHPMEVENT26.get());
    builder.addMode(MHPMEVENT27.get());
    builder.addMode(MHPMEVENT28.get());
    builder.addMode(MHPMEVENT29.get());
    builder.addMode(MHPMEVENT30.get());
    builder.addMode(MHPMEVENT31.get());
    builder.addMode(TSELECT.get());
    builder.addMode(TDATA1.get());
    builder.addMode(TDATA2.get());
    builder.addMode(TDATA3.get());
    builder.addMode(DCSR.get());
    builder.addMode(DPC.get());
    builder.addMode(DSCRATCH.get());
    builder.addMode(CSR_MODE.get());
    builder.addMode(JUMP_IMM.get());
    builder.addMode(JUMP_LABEL_JAL.get());
    builder.addMode(JUMP_ADDR_JAL.get());
    builder.addMode(BRANCH_LABEL.get());
    builder.addMode(BRANCH_IMM.get());
    builder.addMode(BRANCH_OFFSET.get());
    builder.addMode(CX.get());
    builder.addMode(CF.get());
    builder.addMode(C_JUMP_IMM.get());
    builder.addMode(C_JUMP_LABEL.get());
    builder.addMode(C_JUMP_ADDR.get());
    builder.addMode(C_BRANCH_IMM.get());
    builder.addMode(C_BRANCH_LABEL_M2.get());
    builder.addMode(C_BRANCH_OFFSET_M2.get());
    builder.addMode(VR.get());
    builder.addMode(DELTA_LABEL.get());
    builder.addMode(DELTA_IMM.get());
    builder.addMode(DELTA.get());

    builder.addOperation(print_imm12.get());
    builder.addOperation(flw.get());
    builder.addOperation(fsw.get());
    builder.addOperation(fadd_s.get());
    builder.addOperation(fsub_s.get());
    builder.addOperation(fmul_s.get());
    builder.addOperation(fdiv_s.get());
    builder.addOperation(fmin_s.get());
    builder.addOperation(fmax_s.get());
    builder.addOperation(fsqrt_s.get());
    builder.addOperation(fsgnj_s.get());
    builder.addOperation(fsgnjn_s.get());
    builder.addOperation(fsgnjx_s.get());
    builder.addOperation(fmadd_s.get());
    builder.addOperation(fmsub_s.get());
    builder.addOperation(fnmadd_s.get());
    builder.addOperation(fnmsub_s.get());
    builder.addOperation(fcvt_w_s.get());
    builder.addOperation(fcvt_w_s2.get());
    builder.addOperation(fcvt_wu_s.get());
    builder.addOperation(fcvt_wu_s2.get());
    builder.addOperation(fcvt_s_w.get());
    builder.addOperation(fcvt_s_wu.get());
    builder.addOperation(fmv_x_w.get());
    builder.addOperation(fmv_w_x.get());
    builder.addOperation(feq_s.get());
    builder.addOperation(flt_s.get());
    builder.addOperation(fle_s.get());
    builder.addOperation(fclass_s.get());
    builder.addOperation(fmv_s.get());
    builder.addOperation(fabs_s.get());
    builder.addOperation(fneg_s.get());
    builder.addOperation(fmv_x_s.get());
    builder.addOperation(fmv_s_x.get());
    builder.addOperation(rv32f_pseudo.get());
    builder.addOperation(rv32f.get());
    builder.addOperation(fld.get());
    builder.addOperation(fsd.get());
    builder.addOperation(fadd_d.get());
    builder.addOperation(fsub_d.get());
    builder.addOperation(fmul_d.get());
    builder.addOperation(fdiv_d.get());
    builder.addOperation(fmin_d.get());
    builder.addOperation(fmax_d.get());
    builder.addOperation(fsqrt_d.get());
    builder.addOperation(fsgnj_d.get());
    builder.addOperation(fsgnjn_d.get());
    builder.addOperation(fsgnjx_d.get());
    builder.addOperation(fmadd_d.get());
    builder.addOperation(fmsub_d.get());
    builder.addOperation(fnmadd_d.get());
    builder.addOperation(fnmsub_d.get());
    builder.addOperation(fcvt_w_d.get());
    builder.addOperation(fcvt_w_d2.get());
    builder.addOperation(fcvt_wu_d.get());
    builder.addOperation(fcvt_wu_d2.get());
    builder.addOperation(fcvt_d_w.get());
    builder.addOperation(fcvt_d_wu.get());
    builder.addOperation(fcvt_s_d.get());
    builder.addOperation(fcvt_d_s.get());
    builder.addOperation(feq_d.get());
    builder.addOperation(flt_d.get());
    builder.addOperation(fle_d.get());
    builder.addOperation(fclass_d.get());
    builder.addOperation(fmv_d.get());
    builder.addOperation(fabs_d.get());
    builder.addOperation(fneg_d.get());
    builder.addOperation(rv32d_pseudo.get());
    builder.addOperation(rv32d.get());
    builder.addOperation(lwu.get());
    builder.addOperation(ld.get());
    builder.addOperation(sd.get());
    builder.addOperation(addiw.get());
    builder.addOperation(slliw.get());
    builder.addOperation(srliw.get());
    builder.addOperation(sraiw.get());
    builder.addOperation(addw.get());
    builder.addOperation(subw.get());
    builder.addOperation(sllw.get());
    builder.addOperation(srlw.get());
    builder.addOperation(sraw.get());
    builder.addOperation(rv64i.get());
    builder.addOperation(lui.get());
    builder.addOperation(auipc.get());
    builder.addOperation(jal.get());
    builder.addOperation(jalr.get());
    builder.addOperation(beq.get());
    builder.addOperation(bne.get());
    builder.addOperation(blt.get());
    builder.addOperation(bltu.get());
    builder.addOperation(bge.get());
    builder.addOperation(bgeu.get());
    builder.addOperation(lw.get());
    builder.addOperation(lh.get());
    builder.addOperation(lhu.get());
    builder.addOperation(lb.get());
    builder.addOperation(lbu.get());
    builder.addOperation(sw.get());
    builder.addOperation(sh.get());
    builder.addOperation(sb.get());
    builder.addOperation(rv32i_mmu.get());
    builder.addOperation(addi.get());
    builder.addOperation(slti.get());
    builder.addOperation(sltiu.get());
    builder.addOperation(xori.get());
    builder.addOperation(ori.get());
    builder.addOperation(andi.get());
    builder.addOperation(slli.get());
    builder.addOperation(srli.get());
    builder.addOperation(srai.get());
    builder.addOperation(sll.get());
    builder.addOperation(srl.get());
    builder.addOperation(sra.get());
    builder.addOperation(add.get());
    builder.addOperation(sub.get());
    builder.addOperation(slt.get());
    builder.addOperation(sltu.get());
    builder.addOperation(and.get());
    builder.addOperation(or.get());
    builder.addOperation(xor.get());
    builder.addOperation(nop.get());
    builder.addOperation(mv.get());
    builder.addOperation(not.get());
    builder.addOperation(neg.get());
    builder.addOperation(seqz.get());
    builder.addOperation(snez.get());
    builder.addOperation(sltz.get());
    builder.addOperation(sgtz.get());
    builder.addOperation(j.get());
    builder.addOperation(jr.get());
    builder.addOperation(beqz.get());
    builder.addOperation(bnez.get());
    builder.addOperation(blez.get());
    builder.addOperation(bgez.get());
    builder.addOperation(bltz.get());
    builder.addOperation(bgtz.get());
    builder.addOperation(rv32i.get());
    builder.addOperation(rv32i_load_upper_imm.get());
    builder.addOperation(rv32i_arithmetic_rrr.get());
    builder.addOperation(rv32i_arithmetic_rri.get());
    builder.addOperation(c_addi4spn.get());
    builder.addOperation(c_flw.get());
    builder.addOperation(c_fld.get());
    builder.addOperation(c_sw.get());
    builder.addOperation(c_sd.get());
    builder.addOperation(c_fsw.get());
    builder.addOperation(c_fsd.get());
    builder.addOperation(c_nop.get());
    builder.addOperation(c_addi.get());
    builder.addOperation(c_addiw.get());
    builder.addOperation(c_addi16sp.get());
    builder.addOperation(c_li.get());
    builder.addOperation(c_lui.get());
    builder.addOperation(c_srli.get());
    builder.addOperation(c_srai.get());
    builder.addOperation(c_lwsp.get());
    builder.addOperation(c_ldsp.get());
    builder.addOperation(c_swsp.get());
    builder.addOperation(c_sdsp.get());
    builder.addOperation(c_lw.get());
    builder.addOperation(c_ld.get());
    builder.addOperation(c_andi.get());
    builder.addOperation(c_add.get());
    builder.addOperation(c_or.get());
    builder.addOperation(c_xor.get());
    builder.addOperation(c_sub.get());
    builder.addOperation(c_and.get());
    builder.addOperation(c_addw.get());
    builder.addOperation(c_subw.get());
    builder.addOperation(c_j.get());
    builder.addOperation(c_jal.get());
    builder.addOperation(c_beqz.get());
    builder.addOperation(c_bnez.get());
    builder.addOperation(c_jr.get());
    builder.addOperation(c_jalr.get());
    builder.addOperation(c_slli.get());
    builder.addOperation(c_flwsp.get());
    builder.addOperation(c_fldsp.get());
    builder.addOperation(c_mv.get());
    builder.addOperation(c_ebreak.get());
    builder.addOperation(c_fswsp.get());
    builder.addOperation(c_fsdsp.get());
    builder.addOperation(rvc.get());
    builder.addOperation(vadd.get());
    builder.addOperation(vsub.get());
    builder.addOperation(vsl.get());
    builder.addOperation(vsr.get());
    builder.addOperation(vand.get());
    builder.addOperation(vor.get());
    builder.addOperation(vxor.get());
    builder.addOperation(vseq.get());
    builder.addOperation(vsne.get());
    builder.addOperation(vslt.get());
    builder.addOperation(vsge.get());
    builder.addOperation(vclip.get());
    builder.addOperation(vcvt.get());
    builder.addOperation(vmpop.get());
    builder.addOperation(vmfirst.get());
    builder.addOperation(vextract.get());
    builder.addOperation(vinsert.get());
    builder.addOperation(vmerge.get());
    builder.addOperation(vselect.get());
    builder.addOperation(vslide.get());
    builder.addOperation(vdiv.get());
    builder.addOperation(vrem.get());
    builder.addOperation(vmul.get());
    builder.addOperation(vmulh.get());
    builder.addOperation(vmin.get());
    builder.addOperation(vmax.get());
    builder.addOperation(vsgnj.get());
    builder.addOperation(vsgnjn.get());
    builder.addOperation(vsgnjx.get());
    builder.addOperation(vsqrt.get());
    builder.addOperation(vclass.get());
    builder.addOperation(vpopc.get());
    builder.addOperation(vaddi.get());
    builder.addOperation(vsli.get());
    builder.addOperation(vsri.get());
    builder.addOperation(vandi.get());
    builder.addOperation(vori.get());
    builder.addOperation(vxori.get());
    builder.addOperation(vclipi.get());
    builder.addOperation(vmadd.get());
    builder.addOperation(vmsub.get());
    builder.addOperation(vnmadd.get());
    builder.addOperation(vnmsub.get());
    builder.addOperation(vld.get());
    builder.addOperation(vlds.get());
    builder.addOperation(vldx.get());
    builder.addOperation(vst.get());
    builder.addOperation(vsts.get());
    builder.addOperation(vstx.get());
    builder.addOperation(vamoswap.get());
    builder.addOperation(vamoadd.get());
    builder.addOperation(vamoand.get());
    builder.addOperation(vamoor.get());
    builder.addOperation(vamoxor.get());
    builder.addOperation(vamomin.get());
    builder.addOperation(vamomax.get());
    builder.addOperation(rv32v.get());
    builder.addOperation(fcvt_l_d.get());
    builder.addOperation(fcvt_l_d2.get());
    builder.addOperation(fcvt_lu_d.get());
    builder.addOperation(fcvt_lu_d2.get());
    builder.addOperation(fcvt_d_l.get());
    builder.addOperation(fcvt_d_lu.get());
    builder.addOperation(fmv_x_d.get());
    builder.addOperation(fmv_d_x.get());
    builder.addOperation(rv64d.get());
    builder.addOperation(fcvt_l_s.get());
    builder.addOperation(fcvt_l_s2.get());
    builder.addOperation(fcvt_lu_s.get());
    builder.addOperation(fcvt_lu_s2.get());
    builder.addOperation(fcvt_s_l.get());
    builder.addOperation(fcvt_s_lu.get());
    builder.addOperation(rv64f.get());
    builder.addOperation(lr_d.get());
    builder.addOperation(sc_d.get());
    builder.addOperation(amoswap_d.get());
    builder.addOperation(amoadd_d.get());
    builder.addOperation(amoand_d.get());
    builder.addOperation(amoor_d.get());
    builder.addOperation(amoxor_d.get());
    builder.addOperation(amomin_d.get());
    builder.addOperation(amomax_d.get());
    builder.addOperation(amominu_d.get());
    builder.addOperation(amomaxu_d.get());
    builder.addOperation(rv64a.get());
    builder.addOperation(mulw.get());
    builder.addOperation(divw.get());
    builder.addOperation(divuw.get());
    builder.addOperation(remw.get());
    builder.addOperation(remuw.get());
    builder.addOperation(rv64m.get());
    builder.addOperation(lr_w.get());
    builder.addOperation(sc_w.get());
    builder.addOperation(amoswap_w.get());
    builder.addOperation(amoadd_w.get());
    builder.addOperation(amoand_w.get());
    builder.addOperation(amoor_w.get());
    builder.addOperation(amoxor_w.get());
    builder.addOperation(amomin_w.get());
    builder.addOperation(amomax_w.get());
    builder.addOperation(amominu_w.get());
    builder.addOperation(amomaxu_w.get());
    builder.addOperation(rv32a.get());
    builder.addOperation(mul.get());
    builder.addOperation(mulh.get());
    builder.addOperation(mulhu.get());
    builder.addOperation(mulhsu.get());
    builder.addOperation(div.get());
    builder.addOperation(divu.get());
    builder.addOperation(rem.get());
    builder.addOperation(remu.get());
    builder.addOperation(rv32m.get());
    builder.addOperation(ecall.get());
    builder.addOperation(ebreak.get());
    builder.addOperation(fence.get());
    builder.addOperation(fence_i.get());
    builder.addOperation(mret.get());
    builder.addOperation(sret.get());
    builder.addOperation(uret.get());
    builder.addOperation(wfi.get());
    builder.addOperation(csrrw.get());
    builder.addOperation(csrrs.get());
    builder.addOperation(csrrc.get());
    builder.addOperation(csrrwi.get());
    builder.addOperation(csrrsi.get());
    builder.addOperation(csrrci.get());
    builder.addOperation(csrw.get());
    builder.addOperation(csrr.get());
    builder.addOperation(csrs.get());
    builder.addOperation(csrc.get());
    builder.addOperation(csrwi.get());
    builder.addOperation(csrsi.get());
    builder.addOperation(csrci.get());
    builder.addOperation(frcsr.get());
    builder.addOperation(fscsr.get());
    builder.addOperation(fscsr2.get());
    builder.addOperation(frrm.get());
    builder.addOperation(fsrm.get());
    builder.addOperation(fsrm2.get());
    builder.addOperation(fsrmi.get());
    builder.addOperation(fsrmi2.get());
    builder.addOperation(frflags.get());
    builder.addOperation(fsflags.get());
    builder.addOperation(fsflags2.get());
    builder.addOperation(fsflagsi.get());
    builder.addOperation(fsflagsi2.get());
    builder.addOperation(rdinstret.get());
    builder.addOperation(rdcycle.get());
    builder.addOperation(rdtime.get());
    builder.addOperation(rv32i_system.get());
    builder.addOperation(rv32i_pseudo_system.get());
    builder.addOperation(rv32i_sys.get());
    builder.addOperation(Op.get());
    builder.addOperation(Op16.get());
    builder.addOperation(instruction.get());
    builder.addOperation(instruction16.get());
    builder.addOperation(la.get());
    builder.addOperation(lla.get());
    builder.addOperation(lb_global.get());
    builder.addOperation(lh_global.get());
    builder.addOperation(lh_global2.get());
    builder.addOperation(lw_global.get());
    builder.addOperation(ld_global.get());
    builder.addOperation(sb_global.get());
    builder.addOperation(sh_global.get());
    builder.addOperation(sh_global2.get());
    builder.addOperation(sw_global.get());
    builder.addOperation(sd_global.get());
    builder.addOperation(li32.get());
    builder.addOperation(li64.get());
    builder.addOperation(li.get());
    builder.addOperation(flw_global.get());
    builder.addOperation(fld_global.get());
    builder.addOperation(fsw_global.get());
    builder.addOperation(fsd_global.get());
    builder.addOperation(call.get());
    builder.addOperation(tail.get());
    builder.addOperation(ret.get());

    return builder.build();
  }
}
