/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.mode;

import ru.ispras.microtesk.model.*;

public class CSR_MODE extends IsaPrimitive {
  private CSR_MODE() {}
  static {new CSR_MODE();}

  public static final String NAME = "CSR_MODE";

  public static final IsaPrimitiveInfoOr INFO = new IsaPrimitiveInfoOr(
      IsaPrimitiveKind.MODE,
      NAME,
      USTATUS.INFO,
      UIE.INFO,
      UTVEC.INFO,
      USCRATCH.INFO,
      UEPC.INFO,
      UCAUSE.INFO,
      UTVAL.INFO,
      UIP.INFO,
      FFLAGS.INFO,
      FRM.INFO,
      FCSR.INFO,
      CYCLE.INFO,
      TIME.INFO,
      INSTRET.INFO,
      HPMCOUNTER3.INFO,
      HPMCOUNTER4.INFO,
      HPMCOUNTER5.INFO,
      HPMCOUNTER6.INFO,
      HPMCOUNTER7.INFO,
      HPMCOUNTER8.INFO,
      HPMCOUNTER9.INFO,
      HPMCOUNTER10.INFO,
      HPMCOUNTER11.INFO,
      HPMCOUNTER12.INFO,
      HPMCOUNTER13.INFO,
      HPMCOUNTER14.INFO,
      HPMCOUNTER15.INFO,
      HPMCOUNTER16.INFO,
      HPMCOUNTER17.INFO,
      HPMCOUNTER18.INFO,
      HPMCOUNTER19.INFO,
      HPMCOUNTER20.INFO,
      HPMCOUNTER21.INFO,
      HPMCOUNTER22.INFO,
      HPMCOUNTER23.INFO,
      HPMCOUNTER24.INFO,
      HPMCOUNTER25.INFO,
      HPMCOUNTER26.INFO,
      HPMCOUNTER27.INFO,
      HPMCOUNTER28.INFO,
      HPMCOUNTER29.INFO,
      HPMCOUNTER30.INFO,
      HPMCOUNTER31.INFO,
      SSTATUS.INFO,
      SEDELEG.INFO,
      SIDELEG.INFO,
      SIE.INFO,
      STVEC.INFO,
      SCOUNTEREN.INFO,
      SSCRATCH.INFO,
      SEPC.INFO,
      SCAUSE.INFO,
      STVAL.INFO,
      SIP.INFO,
      SATP.INFO,
      MVENDORID.INFO,
      MARCHID.INFO,
      MIMPID.INFO,
      MHARTID.INFO,
      MSTATUS.INFO,
      MISA.INFO,
      MEDELEG.INFO,
      MIDELEG.INFO,
      MIE.INFO,
      MTVEC.INFO,
      MCOUNTEREN.INFO,
      MSCRATCH.INFO,
      MEPC.INFO,
      MCAUSE.INFO,
      MTVAL.INFO,
      MIP.INFO,
      PMPCFG0.INFO,
      PMPCFG1.INFO,
      PMPCFG2.INFO,
      PMPCFG3.INFO,
      PMPADDR0.INFO,
      PMPADDR1.INFO,
      PMPADDR2.INFO,
      PMPADDR3.INFO,
      PMPADDR4.INFO,
      PMPADDR5.INFO,
      PMPADDR6.INFO,
      PMPADDR7.INFO,
      PMPADDR8.INFO,
      PMPADDR9.INFO,
      PMPADDR10.INFO,
      PMPADDR11.INFO,
      PMPADDR12.INFO,
      PMPADDR13.INFO,
      PMPADDR14.INFO,
      PMPADDR15.INFO,
      MCYCLE.INFO,
      MINSTRET.INFO,
      MHPMCOUNTER3.INFO,
      MHPMCOUNTER4.INFO,
      MHPMCOUNTER5.INFO,
      MHPMCOUNTER6.INFO,
      MHPMCOUNTER7.INFO,
      MHPMCOUNTER8.INFO,
      MHPMCOUNTER9.INFO,
      MHPMCOUNTER10.INFO,
      MHPMCOUNTER11.INFO,
      MHPMCOUNTER12.INFO,
      MHPMCOUNTER13.INFO,
      MHPMCOUNTER14.INFO,
      MHPMCOUNTER15.INFO,
      MHPMCOUNTER16.INFO,
      MHPMCOUNTER17.INFO,
      MHPMCOUNTER18.INFO,
      MHPMCOUNTER19.INFO,
      MHPMCOUNTER20.INFO,
      MHPMCOUNTER21.INFO,
      MHPMCOUNTER22.INFO,
      MHPMCOUNTER23.INFO,
      MHPMCOUNTER24.INFO,
      MHPMCOUNTER25.INFO,
      MHPMCOUNTER26.INFO,
      MHPMCOUNTER27.INFO,
      MHPMCOUNTER28.INFO,
      MHPMCOUNTER29.INFO,
      MHPMCOUNTER30.INFO,
      MHPMCOUNTER31.INFO,
      MHPMEVENT3.INFO,
      MHPMEVENT4.INFO,
      MHPMEVENT5.INFO,
      MHPMEVENT6.INFO,
      MHPMEVENT7.INFO,
      MHPMEVENT8.INFO,
      MHPMEVENT9.INFO,
      MHPMEVENT10.INFO,
      MHPMEVENT11.INFO,
      MHPMEVENT12.INFO,
      MHPMEVENT13.INFO,
      MHPMEVENT14.INFO,
      MHPMEVENT15.INFO,
      MHPMEVENT16.INFO,
      MHPMEVENT17.INFO,
      MHPMEVENT18.INFO,
      MHPMEVENT19.INFO,
      MHPMEVENT20.INFO,
      MHPMEVENT21.INFO,
      MHPMEVENT22.INFO,
      MHPMEVENT23.INFO,
      MHPMEVENT24.INFO,
      MHPMEVENT25.INFO,
      MHPMEVENT26.INFO,
      MHPMEVENT27.INFO,
      MHPMEVENT28.INFO,
      MHPMEVENT29.INFO,
      MHPMEVENT30.INFO,
      MHPMEVENT31.INFO,
      TSELECT.INFO,
      TDATA1.INFO,
      TDATA2.INFO,
      TDATA3.INFO,
      DCSR.INFO,
      DPC.INFO,
      DSCRATCH.INFO
  ); 
} 