/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.mode;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.memory.Location;
import ru.ispras.microtesk.model.riscv.PE;
import ru.ispras.microtesk.model.riscv.TempVars;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

public final class JUMP_LABEL_JAL extends IsaPrimitive {
  public static final String NAME = "JUMP_LABEL_JAL";

  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.MODE,
          "JUMP_LABEL_JAL",
          JUMP_LABEL_JAL.class,
          Type.CARD(20)
          );
      addArgument("target", WORD);
      addArgument("current", WORD);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final Immediate target = (Immediate) getArgument("target", args);
      final Immediate current = (Immediate) getArgument("current", args);
      return new JUMP_LABEL_JAL(target, current);
    }
  }

  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final Immediate target;
  public final Immediate current;

  public JUMP_LABEL_JAL(final Immediate target, final Immediate current) {
    this.target = target;
    this.current = current;

    addArgument("target", target);
    addArgument("current", current);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    vars__.jump_imm20.access().store(target.access().bitField(20, 1).load().subtract(current.access().bitField(20, 1).load()));
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("");
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("%1s%10s%1s%8s", vars__.jump_imm20.access().bitField(19, 19).load().toString(), vars__.jump_imm20.access().bitField(9, 0).load().toString(), vars__.jump_imm20.access().bitField(10, 10).load().toString(), vars__.jump_imm20.access().bitField(18, 11).load().toString());
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public Location access(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    return annotate(new Location(target.access().bitField(20, 1).load().subtract(current.access().bitField(20, 1).load())), vars__);
  }
}