/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.mode;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.memory.Location;
import ru.ispras.microtesk.model.riscv.PE;
import ru.ispras.microtesk.model.riscv.TempVars;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

public final class X extends IsaPrimitive {
  public static final String NAME = "X";

  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.MODE,
          "X",
          X.class,
          XWORD
          );
      addArgument("i", Type.CARD(5));
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final Immediate i = (Immediate) getArgument("i", args);
      return new X(i);
    }
  }

  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final Immediate i;

  public X(final Immediate i) {
    this.i = i;

    addArgument("i", i);
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("%s", (i.access().load().equals(Data.valueOf(Type.CARD(5), 0x0)) ? new ZERO().text(vars__) : (i.access().load().equals(Data.valueOf(Type.CARD(5), 0x1)) ? new RA().text(vars__) : (i.access().load().equals(Data.valueOf(Type.CARD(5), 0x2)) ? new SP().text(vars__) : (i.access().load().equals(Data.valueOf(Type.CARD(5), 0x3)) ? new GP().text(vars__) : (i.access().load().equals(Data.valueOf(Type.CARD(5), 0x4)) ? new TP().text(vars__) : ((i.access().load().compareTo(Data.valueOf(Type.CARD(5), 0x5)) >= 0) && (i.access().load().compareTo(Data.valueOf(Type.CARD(5), 0x7)) <= 0) ? new TemporariesCaller(new Immediate(Data.coerce(Type.CARD(3), i.access().load().subtract(Data.valueOf(Type.CARD(5), 0x5))))).text(vars__) : ((i.access().load().compareTo(Data.valueOf(Type.CARD(5), 0x8)) >= 0) && (i.access().load().compareTo(Data.valueOf(Type.CARD(5), 0x9)) <= 0) ? new SavedCallee(new Immediate(Data.coerce(Type.CARD(4), i.access().load().subtract(Data.valueOf(Type.CARD(5), 0x8))))).text(vars__) : ((i.access().load().compareTo(Data.valueOf(Type.CARD(5), 0xa)) >= 0) && (i.access().load().compareTo(Data.valueOf(Type.CARD(5), 0x11)) <= 0) ? new FunctionCaller(new Immediate(Data.coerce(Type.CARD(3), i.access().load().subtract(Data.valueOf(Type.CARD(5), 0xa))))).text(vars__) : ((i.access().load().compareTo(Data.valueOf(Type.CARD(5), 0x12)) >= 0) && (i.access().load().compareTo(Data.valueOf(Type.CARD(5), 0x1b)) <= 0) ? new SavedCallee(new Immediate(Data.coerce(Type.CARD(4), i.access().load().subtract(Data.valueOf(Type.CARD(5), 0x10))))).text(vars__) : ((i.access().load().compareTo(Data.valueOf(Type.CARD(5), 0x1c)) >= 0) && (i.access().load().compareTo(Data.valueOf(Type.CARD(5), 0x1f)) <= 0) ? new TemporariesCaller(new Immediate(Data.coerce(Type.CARD(3), i.access().load().subtract(Data.valueOf(Type.CARD(5), 0x19))))).text(vars__) : "error")))))))))));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("%5s", i.access().load().toString());
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public Location access(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    return annotate(pe__.XREG.access(i.access().load()), vars__);
  }
}