/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.riscv.PE;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.mode.*;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

public final class bne extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "bne",
          bne.class,
          null
          );
      addArgument("rs1", X.INFO);
      addArgument("rs2", X.INFO);
      addArgument("imm", BRANCH_OFFSET.INFO);
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final X rs1 = (X) getArgument("rs1", args);
      final X rs2 = (X) getArgument("rs2", args);
      final IsaPrimitive imm = (IsaPrimitive) getArgument("imm", args);

      return new bne(rs1, rs2, imm);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "bne",
          instruction.class,
          null
          );
      addArgument("rs1", X.INFO);
      addArgument("rs2", X.INFO);
      addArgument("imm", BRANCH_OFFSET.INFO);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final X rs1 = (X) getArgument("rs1", args);
      final X rs2 = (X) getArgument("rs2", args);
      final IsaPrimitive imm = (IsaPrimitive) getArgument("imm", args);

      return new instruction(
        new bne(
          rs1,
          rs2,
          imm
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final X rs1;
  public final X rs2;
  public final IsaPrimitive imm;

  public bne(final X rs1, final X rs2, final IsaPrimitive imm) {
    this.rs1 = rs1;
    this.rs2 = rs2;
    this.imm = imm;

    addArgument("rs1", rs1);
    addArgument("rs2", rs2);
    addArgument("imm", imm);
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("bne %s, %s, %s", rs1.text(vars__), rs2.text(vars__), imm.text(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("%32s", new branch_image(rs1, rs2, imm, new Immediate(Data.valueOf(Type.CARD(3), 0x1))).image(vars__));
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    if (!rs1.access(pe__, vars__).load().equals(rs2.access(pe__, vars__).load())) {
      pe__.PC.access().store(pe__.PC.access().load().add(Data.signExtend(XWORD, imm.access(pe__, vars__).load()).shiftLeft(Data.valueOf(XWORD, 0x1))));
    }
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}