/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.riscv.PE;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.mode.*;
import ru.ispras.microtesk.model.memory.Location;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

public final class branch_image extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "branch_image",
          branch_image.class,
          null
          );
      addArgument("rs1", X.INFO);
      addArgument("rs2", X.INFO);
      addArgument("imm", BRANCH_OFFSET.INFO);
      addArgument("branch_index", Type.CARD(3));}

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final X rs1 = (X) getArgument("rs1", args);
      final X rs2 = (X) getArgument("rs2", args);
      final IsaPrimitive imm = (IsaPrimitive) getArgument("imm", args);
      final Immediate branch_index = (Immediate) getArgument("branch_index", args);

      return new branch_image(rs1, rs2, imm, branch_index);
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final X rs1;
  public final X rs2;
  public final IsaPrimitive imm;
  public final Immediate branch_index;

  public branch_image(final X rs1, final X rs2, final IsaPrimitive imm, final Immediate branch_index) {
    this.rs1 = rs1;
    this.rs2 = rs2;
    this.imm = imm;
    this.branch_index = branch_index;

    addArgument("rs1", rs1);
    addArgument("rs2", rs2);
    addArgument("imm", imm);
    addArgument("branch_index", branch_index);
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("");
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("%1s%6s%5s%5s%3s%4s%1s1100011", imm.access(pe__, vars__).bitField(11, 11).load().toString(), imm.access(pe__, vars__).bitField(9, 4).load().toString(), rs2.image(vars__), rs1.image(vars__), branch_index.access().load().toString(), imm.access(pe__, vars__).bitField(3, 0).load().toString(), imm.access(pe__, vars__).bitField(10, 10).load().toString());
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}