/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.riscv.PE;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.memory.Location;
import ru.ispras.microtesk.model.riscv.mode.*;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

public final class c_addi16sp extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "c_addi16sp",
          c_addi16sp.class,
          null
          );
      addArgument("nzimm", Type.INT(10));
      addShortcut(new Info_instruction16(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final Immediate nzimm = (Immediate) getArgument("nzimm", args);

      return new c_addi16sp(nzimm);
    }
  }
  private static final class Info_instruction16 extends IsaPrimitiveInfoAnd {
    Info_instruction16() {
      super(
          IsaPrimitiveKind.OP,
          "c_addi16sp",
          instruction16.class,
          null
          );
      addArgument("nzimm", Type.INT(10));
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final Immediate nzimm = (Immediate) getArgument("nzimm", args);

      return new instruction16(
        new c_addi16sp(
          nzimm
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final Immediate nzimm;

  public c_addi16sp(final Immediate nzimm) {
    this.nzimm = nzimm;

    addArgument("nzimm", nzimm);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    Execution.assertion(!nzimm.access().load().equals(Data.valueOf(Type.INT(10), 0x0)), "C.ADDI16SP: nzimm == 0");
    Execution.assertion(nzimm.access().bitField(3, 0).load().equals(Data.valueOf(Type.INT(4), 0x0)), "C.ADDI16SP: nzimm<3..0> != 0");
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("c.addi16sp %s, %d", new X(new Immediate(Data.valueOf(Type.CARD(5), 0x2))).text(vars__), nzimm.access().load().bigIntegerValue());
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("011%1s%5s%1s%1s%2s%1s01", nzimm.access().bitField(9, 9).load().toString(), new X(new Immediate(Data.valueOf(Type.CARD(5), 0x2))).image(vars__), nzimm.access().bitField(4, 4).load().toString(), nzimm.access().bitField(6, 6).load().toString(), nzimm.access().bitField(8, 7).load().toString(), nzimm.access().bitField(5, 5).load().toString());
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    new addiw(new X(new Immediate(Data.valueOf(Type.CARD(5), 0x2))), new X(new Immediate(Data.valueOf(Type.CARD(5), 0x2))), new Immediate(Data.signExtend(Type.CARD(12), nzimm.access().bitField(9, 4).load()).shiftLeft(Data.valueOf(Type.CARD(12), 0x4)))).execute(pe__, vars__);
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}