/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.riscv.PE;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.mode.*;
import ru.ispras.microtesk.model.memory.Location;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

public final class c_addi4spn extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "c_addi4spn",
          c_addi4spn.class,
          null
          );
      addArgument("rd", CX.INFO);
      addArgument("nzuimm", Type.CARD(10));
      addShortcut(new Info_instruction16(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final CX rd = (CX) getArgument("rd", args);
      final Immediate nzuimm = (Immediate) getArgument("nzuimm", args);

      return new c_addi4spn(rd, nzuimm);
    }
  }
  private static final class Info_instruction16 extends IsaPrimitiveInfoAnd {
    Info_instruction16() {
      super(
          IsaPrimitiveKind.OP,
          "c_addi4spn",
          instruction16.class,
          null
          );
      addArgument("rd", CX.INFO);
      addArgument("nzuimm", Type.CARD(10));
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final CX rd = (CX) getArgument("rd", args);
      final Immediate nzuimm = (Immediate) getArgument("nzuimm", args);

      return new instruction16(
        new c_addi4spn(
          rd,
          nzuimm
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final CX rd;
  public final Immediate nzuimm;

  public c_addi4spn(final CX rd, final Immediate nzuimm) {
    this.rd = rd;
    this.nzuimm = nzuimm;

    addArgument("rd", rd);
    addArgument("nzuimm", nzuimm);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    Execution.assertion(!nzuimm.access().load().equals(Data.valueOf(Type.CARD(10), 0x0)), "C.ADDI4SPN: nzuimm == 0");
    Execution.assertion(nzuimm.access().bitField(1, 0).load().equals(Data.valueOf(Type.CARD(2), 0x0)), "C.ADDI4SPN: nzuimm<1..0> != 0");
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("c.addi4spn %s, %s, %d", rd.text(vars__), new X(new Immediate(Data.valueOf(Type.CARD(5), 0x2))).text(vars__), nzuimm.access().load().bigIntegerValue());
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("000%2s%4s%1s%1s%3s00", nzuimm.access().bitField(5, 4).load().toString(), nzuimm.access().bitField(9, 6).load().toString(), nzuimm.access().bitField(2, 2).load().toString(), nzuimm.access().bitField(3, 3).load().toString(), rd.image(vars__));
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    new addi(new X(new Immediate(Data.zeroExtend(Type.CARD(5), rd.i.access().load()).add(Data.valueOf(Type.CARD(5), 0x8)))), new X(new Immediate(Data.valueOf(Type.CARD(5), 0x2))), new Immediate(Data.zeroExtend(Type.CARD(12), nzuimm.access().bitField(9, 2).load()).shiftLeft(Data.valueOf(Type.CARD(12), 0x2)))).execute(pe__, vars__);
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}