/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.riscv.PE;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.mode.*;
import ru.ispras.microtesk.model.memory.Location;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

public final class c_andi extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "c_andi",
          c_andi.class,
          null
          );
      addArgument("rd", CX.INFO);
      addArgument("imm", Type.INT(6));
      addShortcut(new Info_instruction16(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final CX rd = (CX) getArgument("rd", args);
      final Immediate imm = (Immediate) getArgument("imm", args);

      return new c_andi(rd, imm);
    }
  }
  private static final class Info_instruction16 extends IsaPrimitiveInfoAnd {
    Info_instruction16() {
      super(
          IsaPrimitiveKind.OP,
          "c_andi",
          instruction16.class,
          null
          );
      addArgument("rd", CX.INFO);
      addArgument("imm", Type.INT(6));
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final CX rd = (CX) getArgument("rd", args);
      final Immediate imm = (Immediate) getArgument("imm", args);

      return new instruction16(
        new c_andi(
          rd,
          imm
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final CX rd;
  public final Immediate imm;

  public c_andi(final CX rd, final Immediate imm) {
    this.rd = rd;
    this.imm = imm;

    addArgument("rd", rd);
    addArgument("imm", imm);
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("c.andi %s, %d", rd.text(vars__), imm.access().load().bigIntegerValue());
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("100%1s10%3s%5s01", imm.access().bitField(5, 5).load().toString(), rd.image(vars__), imm.access().bitField(4, 0).load().toString());
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    new andi(new X(new Immediate(Data.zeroExtend(Type.CARD(5), rd.i.access().load()).add(Data.valueOf(Type.CARD(5), 0x8)))), new X(new Immediate(Data.zeroExtend(Type.CARD(5), rd.i.access().load()).add(Data.valueOf(Type.CARD(5), 0x8)))), new Immediate(Data.signExtend(Type.CARD(12), imm.access().load()))).execute(pe__, vars__);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}