/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.riscv.PE;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.mode.*;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

public final class c_bnez extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "c_bnez",
          c_bnez.class,
          null
          );
      addArgument("rs1", CX.INFO);
      addArgument("offset", C_BRANCH_OFFSET_M2.INFO);
      addShortcut(new Info_instruction16(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final CX rs1 = (CX) getArgument("rs1", args);
      final IsaPrimitive offset = (IsaPrimitive) getArgument("offset", args);

      return new c_bnez(rs1, offset);
    }
  }
  private static final class Info_instruction16 extends IsaPrimitiveInfoAnd {
    Info_instruction16() {
      super(
          IsaPrimitiveKind.OP,
          "c_bnez",
          instruction16.class,
          null
          );
      addArgument("rs1", CX.INFO);
      addArgument("offset", C_BRANCH_OFFSET_M2.INFO);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final CX rs1 = (CX) getArgument("rs1", args);
      final IsaPrimitive offset = (IsaPrimitive) getArgument("offset", args);

      return new instruction16(
        new c_bnez(
          rs1,
          offset
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final CX rs1;
  public final IsaPrimitive offset;

  public c_bnez(final CX rs1, final IsaPrimitive offset) {
    this.rs1 = rs1;
    this.offset = offset;

    addArgument("rs1", rs1);
    addArgument("offset", offset);
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("c.bnez %s, %s", rs1.text(vars__), offset.text(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("111%1s%2s%3s%2s%2s%1s01", offset.access(pe__, vars__).bitField(7, 7).load().toString(), offset.access(pe__, vars__).bitField(3, 2).load().toString(), rs1.image(vars__), offset.access(pe__, vars__).bitField(6, 5).load().toString(), offset.access(pe__, vars__).bitField(1, 0).load().toString(), offset.access(pe__, vars__).bitField(4, 4).load().toString());
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    new bne(new X(new Immediate(Data.zeroExtend(Type.CARD(5), rs1.i.access().load()).add(Data.valueOf(Type.CARD(5), 0x8)))), new X(new Immediate(Data.valueOf(Type.CARD(5), 0x0))), new BRANCH_IMM(new Immediate(Data.signExtend(Type.CARD(12), offset.access(pe__, vars__).load())))).execute(pe__, vars__);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}