/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.riscv.PE;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.mode.*;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

public final class c_jal extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "c_jal",
          c_jal.class,
          null
          );
      addArgument("target", C_JUMP_ADDR.INFO);
      addShortcut(new Info_instruction16(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final IsaPrimitive target = (IsaPrimitive) getArgument("target", args);

      return new c_jal(target);
    }
  }
  private static final class Info_instruction16 extends IsaPrimitiveInfoAnd {
    Info_instruction16() {
      super(
          IsaPrimitiveKind.OP,
          "c_jal",
          instruction16.class,
          null
          );
      addArgument("target", C_JUMP_ADDR.INFO);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final IsaPrimitive target = (IsaPrimitive) getArgument("target", args);

      return new instruction16(
        new c_jal(
          target
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final IsaPrimitive target;

  public c_jal(final IsaPrimitive target) {
    this.target = target;

    addArgument("target", target);
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("c.jal %s", target.text(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("001%1s%1s%2s%1s%1s%1s%3s%1s01", target.access(pe__, vars__).bitField(10, 10).load().toString(), target.access(pe__, vars__).bitField(3, 3).load().toString(), target.access(pe__, vars__).bitField(8, 7).load().toString(), target.access(pe__, vars__).bitField(9, 9).load().toString(), target.access(pe__, vars__).bitField(5, 5).load().toString(), target.access(pe__, vars__).bitField(6, 6).load().toString(), target.access(pe__, vars__).bitField(2, 0).load().toString(), target.access(pe__, vars__).bitField(4, 4).load().toString());
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    new jal(new X(new Immediate(Data.valueOf(Type.CARD(5), 0x1))), new JUMP_IMM(new Immediate(Data.signExtend(Type.INT(20), target.access(pe__, vars__).load())))).execute(pe__, vars__);
    pe__.XREG.access(1).store(vars__.prev_pc.access().load().add(Data.valueOf(XWORD, 0x2)));
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}