/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.riscv.PE;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.mode.*;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

public final class c_jalr extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "c_jalr",
          c_jalr.class,
          null
          );
      addArgument("rs1", X.INFO);
      addShortcut(new Info_instruction16(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final X rs1 = (X) getArgument("rs1", args);

      return new c_jalr(rs1);
    }
  }
  private static final class Info_instruction16 extends IsaPrimitiveInfoAnd {
    Info_instruction16() {
      super(
          IsaPrimitiveKind.OP,
          "c_jalr",
          instruction16.class,
          null
          );
      addArgument("rs1", X.INFO);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final X rs1 = (X) getArgument("rs1", args);

      return new instruction16(
        new c_jalr(
          rs1
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final X rs1;

  public c_jalr(final X rs1) {
    this.rs1 = rs1;

    addArgument("rs1", rs1);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    Execution.assertion(!rs1.i.access().load().equals(Data.valueOf(Type.CARD(5), 0x0)), "C.JALR: rs1 == 0");
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("c.jalr %s", rs1.text(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("1001%5s0000010", rs1.image(vars__));
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    new jalr(new X(new Immediate(Data.valueOf(Type.CARD(5), 0x1))), rs1, new Immediate(Data.valueOf(Type.CARD(12), 0x0))).execute(pe__, vars__);
    pe__.XREG.access(1).store(vars__.prev_pc.access().load().add(Data.valueOf(XWORD, 0x2)));
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}