/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.riscv.PE;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.mode.*;
import ru.ispras.microtesk.model.memory.Location;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

public final class c_ld extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "c_ld",
          c_ld.class,
          null
          );
      addArgument("rd", CX.INFO);
      addArgument("rs1", CX.INFO);
      addArgument("offset", Type.CARD(8));
      addShortcut(new Info_instruction16(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final CX rd = (CX) getArgument("rd", args);
      final CX rs1 = (CX) getArgument("rs1", args);
      final Immediate offset = (Immediate) getArgument("offset", args);

      return new c_ld(rd, rs1, offset);
    }
  }
  private static final class Info_instruction16 extends IsaPrimitiveInfoAnd {
    Info_instruction16() {
      super(
          IsaPrimitiveKind.OP,
          "c_ld",
          instruction16.class,
          null
          );
      addArgument("rd", CX.INFO);
      addArgument("rs1", CX.INFO);
      addArgument("offset", Type.CARD(8));
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final CX rd = (CX) getArgument("rd", args);
      final CX rs1 = (CX) getArgument("rs1", args);
      final Immediate offset = (Immediate) getArgument("offset", args);

      return new instruction16(
        new c_ld(
          rd,
          rs1,
          offset
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final CX rd;
  public final CX rs1;
  public final Immediate offset;

  public c_ld(final CX rd, final CX rs1, final Immediate offset) {
    this.rd = rd;
    this.rs1 = rs1;
    this.offset = offset;

    addArgument("rd", rd);
    addArgument("rs1", rs1);
    addArgument("offset", offset);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    Execution.assertion(offset.access().bitField(2, 0).load().equals(Data.valueOf(Type.CARD(3), 0x0)), "C.LD: offset<2..0> != 0");
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("c.ld %s, %d(%s)", rd.text(vars__), offset.access().load().bigIntegerValue(), rs1.text(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("011%3s%3s%2s%3s00", offset.access().bitField(5, 3).load().toString(), rs1.image(vars__), offset.access().bitField(7, 6).load().toString(), rd.image(vars__));
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    new ld(new X(new Immediate(Data.zeroExtend(Type.CARD(5), rd.i.access().load()).add(Data.valueOf(Type.CARD(5), 0x8)))), new X(new Immediate(Data.zeroExtend(Type.CARD(5), rs1.i.access().load()).add(Data.valueOf(Type.CARD(5), 0x8)))), new Immediate(Data.zeroExtend(Type.CARD(12), offset.access().bitField(7, 3).load()).shiftLeft(Data.valueOf(Type.CARD(12), 0x3)))).execute(pe__, vars__);
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}