/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.riscv.PE;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.mode.*;
import ru.ispras.microtesk.model.memory.Location;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

public final class c_lui extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "c_lui",
          c_lui.class,
          null
          );
      addArgument("rd", X.INFO);
      addArgument("imm", Type.CARD(20));
      addShortcut(new Info_instruction16(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final X rd = (X) getArgument("rd", args);
      final Immediate imm = (Immediate) getArgument("imm", args);

      return new c_lui(rd, imm);
    }
  }
  private static final class Info_instruction16 extends IsaPrimitiveInfoAnd {
    Info_instruction16() {
      super(
          IsaPrimitiveKind.OP,
          "c_lui",
          instruction16.class,
          null
          );
      addArgument("rd", X.INFO);
      addArgument("imm", Type.CARD(20));
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final X rd = (X) getArgument("rd", args);
      final Immediate imm = (Immediate) getArgument("imm", args);

      return new instruction16(
        new c_lui(
          rd,
          imm
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final X rd;
  public final Immediate imm;

  public c_lui(final X rd, final Immediate imm) {
    this.rd = rd;
    this.imm = imm;

    addArgument("rd", rd);
    addArgument("imm", imm);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    Execution.assertion(!imm.access().load().equals(Data.valueOf(Type.CARD(20), 0x0)), "C.LUI: imm == 0 (invalid)");
    Execution.assertion(!rd.i.access().load().equals(Data.valueOf(Type.CARD(5), 0x0)), "C.LUI: rd == x0 (invalid)");
    Execution.assertion(!rd.i.access().load().equals(Data.valueOf(Type.CARD(5), 0x2)), "C.LUI: rd == x2 (invalid)");
    Execution.assertion(imm.access().bitField(19, 6).load().equals(Data.signExtend(Type.CARD(14), imm.access().bitField(5, 5).load())), "C.LUI: imm is not a sign-extended 6-bit value");
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("c.lui %s, 0x%x", rd.text(vars__), imm.access().load().bigIntegerValue(false));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("011%1s%5s%5s01", imm.access().bitField(5, 5).load().toString(), rd.image(vars__), imm.access().bitField(4, 0).load().toString());
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    new lui(rd, imm).execute(pe__, vars__);
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}