/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.riscv.PE;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.mode.*;
import ru.ispras.microtesk.model.memory.Location;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

public final class c_lwsp extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "c_lwsp",
          c_lwsp.class,
          null
          );
      addArgument("rd", X.INFO);
      addArgument("offset", Type.CARD(8));
      addShortcut(new Info_instruction16(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final X rd = (X) getArgument("rd", args);
      final Immediate offset = (Immediate) getArgument("offset", args);

      return new c_lwsp(rd, offset);
    }
  }
  private static final class Info_instruction16 extends IsaPrimitiveInfoAnd {
    Info_instruction16() {
      super(
          IsaPrimitiveKind.OP,
          "c_lwsp",
          instruction16.class,
          null
          );
      addArgument("rd", X.INFO);
      addArgument("offset", Type.CARD(8));
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final X rd = (X) getArgument("rd", args);
      final Immediate offset = (Immediate) getArgument("offset", args);

      return new instruction16(
        new c_lwsp(
          rd,
          offset
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final X rd;
  public final Immediate offset;

  public c_lwsp(final X rd, final Immediate offset) {
    this.rd = rd;
    this.offset = offset;

    addArgument("rd", rd);
    addArgument("offset", offset);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    Execution.assertion(!rd.i.access().load().equals(Data.valueOf(Type.CARD(5), 0x0)), "C.LWSP: rd == x0");
    Execution.assertion(offset.access().bitField(1, 0).load().equals(Data.valueOf(Type.CARD(2), 0x0)), "C.LWSP: offset<1..0> != 0");
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("c.lwsp %s, %d(%s)", rd.text(vars__), offset.access().load().bigIntegerValue(), new X(new Immediate(Data.valueOf(Type.CARD(5), 0x2))).text(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("010%1s%5s%3s%2s10", offset.access().bitField(5, 5).load().toString(), rd.image(vars__), offset.access().bitField(4, 2).load().toString(), offset.access().bitField(7, 6).load().toString());
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    new lw(rd, new X(new Immediate(Data.valueOf(Type.CARD(5), 0x2))), new Immediate(Data.zeroExtend(Type.CARD(12), offset.access().bitField(7, 2).load()).shiftLeft(Data.valueOf(Type.CARD(12), 0x2)))).execute(pe__, vars__);
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}