/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.riscv.PE;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.mode.*;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

public final class c_or extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "c_or",
          c_or.class,
          null
          );
      addArgument("rd", CX.INFO);
      addArgument("rs2", CX.INFO);
      addShortcut(new Info_instruction16(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final CX rd = (CX) getArgument("rd", args);
      final CX rs2 = (CX) getArgument("rs2", args);

      return new c_or(rd, rs2);
    }
  }
  private static final class Info_instruction16 extends IsaPrimitiveInfoAnd {
    Info_instruction16() {
      super(
          IsaPrimitiveKind.OP,
          "c_or",
          instruction16.class,
          null
          );
      addArgument("rd", CX.INFO);
      addArgument("rs2", CX.INFO);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final CX rd = (CX) getArgument("rd", args);
      final CX rs2 = (CX) getArgument("rs2", args);

      return new instruction16(
        new c_or(
          rd,
          rs2
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final CX rd;
  public final CX rs2;

  public c_or(final CX rd, final CX rs2) {
    this.rd = rd;
    this.rs2 = rs2;

    addArgument("rd", rd);
    addArgument("rs2", rs2);
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("c.or %s, %s", rd.text(vars__), rs2.text(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("100011%3s10%3s01", rd.image(vars__), rs2.image(vars__));
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    new or(new X(new Immediate(Data.zeroExtend(Type.CARD(5), rd.i.access().load()).add(Data.valueOf(Type.CARD(5), 0x8)))), new X(new Immediate(Data.zeroExtend(Type.CARD(5), rd.i.access().load()).add(Data.valueOf(Type.CARD(5), 0x8)))), new X(new Immediate(Data.zeroExtend(Type.CARD(5), rs2.i.access().load()).add(Data.valueOf(Type.CARD(5), 0x8))))).execute(pe__, vars__);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}