/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.riscv.PE;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.mode.*;
import ru.ispras.microtesk.model.memory.Location;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

public final class fcvt_lu_s extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "fcvt_lu_s",
          fcvt_lu_s.class,
          null
          );
      addArgument("rd", X.INFO);
      addArgument("rs1", F.INFO);
      addArgument("op_round_mod", Type.CARD(3));
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final X rd = (X) getArgument("rd", args);
      final F rs1 = (F) getArgument("rs1", args);
      final Immediate op_round_mod = (Immediate) getArgument("op_round_mod", args);

      return new fcvt_lu_s(rd, rs1, op_round_mod);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "fcvt_lu_s",
          instruction.class,
          null
          );
      addArgument("rd", X.INFO);
      addArgument("rs1", F.INFO);
      addArgument("op_round_mod", Type.CARD(3));
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final X rd = (X) getArgument("rd", args);
      final F rs1 = (F) getArgument("rs1", args);
      final Immediate op_round_mod = (Immediate) getArgument("op_round_mod", args);

      return new instruction(
        new fcvt_lu_s(
          rd,
          rs1,
          op_round_mod
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final X rd;
  public final F rs1;
  public final Immediate op_round_mod;

  public fcvt_lu_s(final X rd, final F rs1, final Immediate op_round_mod) {
    this.rd = rd;
    this.rs1 = rs1;
    this.op_round_mod = op_round_mod;

    addArgument("rd", rd);
    addArgument("rs1", rs1);
    addArgument("op_round_mod", op_round_mod);
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("fcvt.lu.s %s, %s", rd.text(vars__), rs1.text(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("1100000%5s%5s%3s%5s1010011", "00011", rs1.image(vars__), op_round_mod.access().load().toString(), rd.image(vars__));
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    vars__.tmp_ui3.access().store(Data.valueOf(Type.CARD(3), Execution.float_rounding_mode.load()));
    new setSFRoundingMode(op_round_mod).execute(pe__, vars__);
    vars__.temp_fps.access().bitField(31, 0).store(rs1.access(pe__, vars__).bitField(31, 0).load());
    if (rs1.access(pe__, vars__).bitField(31, 31).load().equals(Data.valueOf(Type.CARD(1), 0x1))) {
      rd.access(pe__, vars__).store(Data.valueOf(XWORD, 0x0));
      if (vars__.temp_fps.access().load().isNan()) {
        rd.access(pe__, vars__).store(Data.valueOf(XWORD, new BigInteger("ffffffffffffffff", 16)));
      } else {
        rd.access(pe__, vars__).store(Data.valueOf(XWORD, 0x0));
      }
    } else {
      vars__.exponent.access().store(rs1.access(pe__, vars__).bitField(30, 23).load());
      vars__.precision.access().store(rs1.access(pe__, vars__).bitField(22, 0).load());
      if (vars__.temp_fps.access().load().isNan()) {
        rd.access(pe__, vars__).store(Data.valueOf(XWORD, new BigInteger("ffffffffffffffff", 16)));
      } else if (vars__.exponent.access().load().equals(Data.valueOf(Type.CARD(8), 0xff)) && vars__.precision.access().load().equals(Data.valueOf(Type.CARD(23), 0x0))) {
        rd.access(pe__, vars__).store(Data.valueOf(XWORD, new BigInteger("ffffffffffffffff", 16)));
      } else {
        new process_float_exception_flags().execute(pe__, vars__);
        rd.access(pe__, vars__).store(Data.floatToInt(DWORD, Data.cast(FLOAT32, rs1.access(pe__, vars__).bitField(31, 0).load())));
        new process_float_exception_flags().execute(pe__, vars__);
        vars__.tmp_word.access().store(Data.valueOf(WORD, 0x7fffffff));
        vars__.temp_fps.access().store(Data.intToFloat(FLOAT32, vars__.tmp_word.access().load()));
        vars__.temp_fps2.access().store(Data.cast(FLOAT32, rs1.access(pe__, vars__).bitField(31, 0).load()));
        if ((vars__.temp_fps2.access().load().compareTo(vars__.temp_fps.access().load()) > 0)) {
          rd.access(pe__, vars__).store(Data.floatToInt(DWORD, vars__.temp_fps2.access().load().subtract(vars__.temp_fps.access().load())));
          rd.access(pe__, vars__).bitField(63, 63).store(Data.valueOf(Type.CARD(1), 0x1));
        }
      }
    }
    Execution.float_rounding_mode.store(vars__.tmp_ui3.access().load());
    if (rs1.access(pe__, vars__).bitField(31, 31).load().equals(Data.valueOf(Type.CARD(1), 0x1))) {
      Execution.float_exception_flags.store(0);
      new process_float_exception_flags().execute(pe__, vars__);
      vars__.tmp_dword.access().store(Data.floatToInt(DWORD, Data.cast(FLOAT32, Location.concat(pe__.XREG.access(0).bitField(1, 1), rs1.access(pe__, vars__).bitField(30, 0)).load())));
      vars__.tmp_word.access().store(Data.valueOf(WORD, Execution.float_exception_flags.load()));
      if (vars__.tmp_word.access().load().equals(Data.valueOf(WORD, 0x0))) {
        pe__.FFLAGS_EXCEP.access().bitField(4, 4).store(Data.valueOf(Type.CARD(1), 0x1));
        pe__.FCSR_EXCEP.access().bitField(4, 4).store(Data.valueOf(Type.CARD(1), 0x1));
      } else {
        new process_float_exception_flags().execute(pe__, vars__);
      }
    }
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}