/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.riscv.PE;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.mode.*;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

public final class lr_w extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "lr_w",
          lr_w.class,
          null
          );
      addArgument("rd", X.INFO);
      addArgument("rs1", X.INFO);
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final X rd = (X) getArgument("rd", args);
      final X rs1 = (X) getArgument("rs1", args);

      return new lr_w(rd, rs1);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "lr_w",
          instruction.class,
          null
          );
      addArgument("rd", X.INFO);
      addArgument("rs1", X.INFO);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final X rd = (X) getArgument("rd", args);
      final X rs1 = (X) getArgument("rs1", args);

      return new instruction(
        new lr_w(
          rd,
          rs1
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final X rd;
  public final X rs1;

  public lr_w(final X rd, final X rs1) {
    this.rd = rd;
    this.rs1 = rs1;

    addArgument("rd", rd);
    addArgument("rs1", rs1);
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("lr.w %s, (%s)", rd.text(vars__), rs1.text(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("%5s%1s%1s%5s%5s%3s%5s0101111", "00010", "0", "0", "00000", rs1.image(vars__), "010", rd.image(vars__));
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    pe__.LOAD_RESERVATION.access().store(rs1.access(pe__, vars__).load());
    new load_data(new Immediate(Data.valueOf(Type.CARD(4), 0x4)), new Immediate(rs1.access(pe__, vars__))).execute(pe__, vars__);
    rd.access(pe__, vars__).store(Data.signExtend(XWORD, vars__.load_value.access().bitField(31, 0).load()));
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}