/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.riscv.PE;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.memory.Location;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

public final class setSFRoundingMode extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "setSFRoundingMode",
          setSFRoundingMode.class,
          null
          );
      addArgument("rmode", Type.CARD(3));}

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final Immediate rmode = (Immediate) getArgument("rmode", args);

      return new setSFRoundingMode(rmode);
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final Immediate rmode;

  public setSFRoundingMode(final Immediate rmode) {
    this.rmode = rmode;

    addArgument("rmode", rmode);
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    if (rmode.access().load().equals(Data.valueOf(Type.CARD(3), 0x0))) {
      Execution.float_rounding_mode.store(Data.valueOf(WORD, 0x0));
    } else if (rmode.access().load().equals(Data.valueOf(Type.CARD(3), 0x1))) {
      Execution.float_rounding_mode.store(Data.valueOf(WORD, 0x3));
    } else if (rmode.access().load().equals(Data.valueOf(Type.CARD(3), 0x2))) {
      Execution.float_rounding_mode.store(Data.valueOf(WORD, 0x2));
    } else if (rmode.access().load().equals(Data.valueOf(Type.CARD(3), 0x3))) {
      Execution.float_rounding_mode.store(Data.valueOf(WORD, 0x1));
    } else if (rmode.access().load().equals(Data.valueOf(Type.CARD(3), 0x4))) {
      Execution.float_rounding_mode.store(Data.valueOf(WORD, 0x4));
    }
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}