/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.riscv.PE;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.mode.*;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

public final class vamomin extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "vamomin",
          vamomin.class,
          null
          );
      addArgument("vd", VR.INFO);
      addArgument("vs2", VR.INFO);
      addArgument("vs3", VR.INFO);
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final VR vd = (VR) getArgument("vd", args);
      final VR vs2 = (VR) getArgument("vs2", args);
      final VR vs3 = (VR) getArgument("vs3", args);

      return new vamomin(vd, vs2, vs3);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "vamomin",
          instruction.class,
          null
          );
      addArgument("vd", VR.INFO);
      addArgument("vs2", VR.INFO);
      addArgument("vs3", VR.INFO);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final VR vd = (VR) getArgument("vd", args);
      final VR vs2 = (VR) getArgument("vs2", args);
      final VR vs3 = (VR) getArgument("vs3", args);

      return new instruction(
        new vamomin(
          vd,
          vs2,
          vs3
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final VR vd;
  public final VR vs2;
  public final VR vs3;

  public vamomin(final VR vd, final VR vs2, final VR vs3) {
    this.vd = vd;
    this.vs2 = vs2;
    this.vs3 = vs3;

    addArgument("vd", vd);
    addArgument("vs2", vs2);
    addArgument("vs3", vs3);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    vars__.im_2b.access().store(Data.valueOf(Type.CARD(2), 0x3));
    vars__.vs2_const.access().store(Data.valueOf(Type.CARD(5), 0x10));
    vars__.vp.access().store(Data.valueOf(BIT, 0x1));
    vars__.m.access().store(Data.valueOf(Type.CARD(2), 0x0));
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("vamomin %s, %s, %s", vd.text(vars__), vs2.text(vars__), vs3.text(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("%5s%2s%5s%5s%1s%2s%5s%7s", vs3.image(vars__), vars__.im_2b.access().load().toString(), vs2.image(vars__), vars__.vs2_const.access().load().toString(), vars__.vp.access().load().toString(), vars__.m.access().load().toString(), vd.image(vars__), Data.valueOf(Type.CARD(7), 0x27).toString());
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}