/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.riscv.PE;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.mode.*;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

public final class vinsert extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "vinsert",
          vinsert.class,
          null
          );
      addArgument("vd", VR.INFO);
      addArgument("rs1", X.INFO);
      addArgument("rs2", X.INFO);
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final VR vd = (VR) getArgument("vd", args);
      final X rs1 = (X) getArgument("rs1", args);
      final X rs2 = (X) getArgument("rs2", args);

      return new vinsert(vd, rs1, rs2);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "vinsert",
          instruction.class,
          null
          );
      addArgument("vd", VR.INFO);
      addArgument("rs1", X.INFO);
      addArgument("rs2", X.INFO);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final VR vd = (VR) getArgument("vd", args);
      final X rs1 = (X) getArgument("rs1", args);
      final X rs2 = (X) getArgument("rs2", args);

      return new instruction(
        new vinsert(
          vd,
          rs1,
          rs2
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final VR vd;
  public final X rs1;
  public final X rs2;

  public vinsert(final VR vd, final X rs1, final X rs2) {
    this.vd = vd;
    this.rs1 = rs1;
    this.rs2 = rs2;

    addArgument("vd", vd);
    addArgument("rs1", rs1);
    addArgument("rs2", rs2);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    vars__.func7_0.access().store(Data.valueOf(Type.CARD(4), 0xb));
    vars__.func7_1.access().store(Data.valueOf(Type.CARD(3), 0x4));
    vars__.vp.access().store(Data.valueOf(BIT, 0x1));
    vars__.m.access().store(Data.valueOf(Type.CARD(2), 0x0));
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("vinsert %s, %s, %s", vd.text(vars__), rs1.text(vars__), rs2.text(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("%4s%3s%5s%5s%1s%2s%5s%7s", vars__.func7_0.access().load().toString(), vars__.func7_1.access().load().toString(), rs2.image(vars__), rs1.image(vars__), vars__.vp.access().load().toString(), vars__.m.access().load().toString(), vd.image(vars__), Data.valueOf(Type.CARD(7), 0x67).toString());
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}