/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.riscv.PE;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.mode.*;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

public final class vmpop extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "vmpop",
          vmpop.class,
          null
          );
      addArgument("rd", X.INFO);
      addArgument("vs1", VR.INFO);
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final X rd = (X) getArgument("rd", args);
      final VR vs1 = (VR) getArgument("vs1", args);

      return new vmpop(rd, vs1);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "vmpop",
          instruction.class,
          null
          );
      addArgument("rd", X.INFO);
      addArgument("vs1", VR.INFO);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final X rd = (X) getArgument("rd", args);
      final VR vs1 = (VR) getArgument("vs1", args);

      return new instruction(
        new vmpop(
          rd,
          vs1
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final X rd;
  public final VR vs1;

  public vmpop(final X rd, final VR vs1) {
    this.rd = rd;
    this.vs1 = vs1;

    addArgument("rd", rd);
    addArgument("vs1", vs1);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    vars__.func7_0.access().store(Data.valueOf(Type.CARD(4), 0xa));
    vars__.func7_1.access().store(Data.valueOf(Type.CARD(3), 0x7));
    vars__.vs2_const.access().store(Data.valueOf(Type.CARD(5), 0x1));
    vars__.vp.access().store(Data.valueOf(BIT, 0x1));
    vars__.m.access().store(Data.valueOf(Type.CARD(2), 0x0));
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("vmpop %s, %s", rd.text(vars__), vs1.text(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("%4s%3s%5s%5s%1s%2s%5s%7s", vars__.func7_0.access().load().toString(), vars__.func7_1.access().load().toString(), vars__.vs2_const.access().load().toString(), vs1.image(vars__), vars__.vp.access().load().toString(), vars__.m.access().load().toString(), rd.image(vars__), Data.valueOf(Type.CARD(7), 0x67).toString());
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}