/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.riscv.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.riscv.PE;
import ru.ispras.microtesk.model.riscv.TempVars;
import ru.ispras.microtesk.model.riscv.mode.*;
import ru.ispras.microtesk.model.memory.Location;

import static ru.ispras.microtesk.model.riscv.TypeDefs.*;

public final class vsts extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "vsts",
          vsts.class,
          null
          );
      addArgument("rs1", X.INFO);
      addArgument("rs2", X.INFO);
      addArgument("vs3", VR.INFO);
      addArgument("imm", Type.CARD(5));
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final X rs1 = (X) getArgument("rs1", args);
      final X rs2 = (X) getArgument("rs2", args);
      final VR vs3 = (VR) getArgument("vs3", args);
      final Immediate imm = (Immediate) getArgument("imm", args);

      return new vsts(rs1, rs2, vs3, imm);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "vsts",
          instruction.class,
          null
          );
      addArgument("rs1", X.INFO);
      addArgument("rs2", X.INFO);
      addArgument("vs3", VR.INFO);
      addArgument("imm", Type.CARD(5));
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final X rs1 = (X) getArgument("rs1", args);
      final X rs2 = (X) getArgument("rs2", args);
      final VR vs3 = (VR) getArgument("vs3", args);
      final Immediate imm = (Immediate) getArgument("imm", args);

      return new instruction(
        new vsts(
          rs1,
          rs2,
          vs3,
          imm
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final X rs1;
  public final X rs2;
  public final VR vs3;
  public final Immediate imm;

  public vsts(final X rs1, final X rs2, final VR vs3, final Immediate imm) {
    this.rs1 = rs1;
    this.rs2 = rs2;
    this.vs3 = vs3;
    this.imm = imm;

    addArgument("rs1", rs1);
    addArgument("rs2", rs2);
    addArgument("vs3", vs3);
    addArgument("imm", imm);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    vars__.im_2b.access().store(Data.valueOf(Type.CARD(2), 0x1));
    vars__.vp.access().store(Data.valueOf(BIT, 0x1));
    vars__.m.access().store(Data.valueOf(Type.CARD(2), 0x0));
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("vsts %s, %s, %s, %d", rs1.text(vars__), rs2.text(vars__), vs3.text(vars__), imm.access().load().bigIntegerValue());
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("%5s%2s%5s%5s%1s%2s%5s%7s", vs3.image(vars__), vars__.im_2b.access().load().toString(), rs2.image(vars__), rs1.image(vars__), vars__.vp.access().load().toString(), vars__.m.access().load().toString(), imm.access().load().toString(), Data.valueOf(Type.CARD(7), 0x27).toString());
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
  }

  @Override
  public void decode(final TemporaryVariables tempVars) {
    final PE pe__ = null;
    final TempVars vars__ = (TempVars) tempVars;
  }
}