/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.decoder;

import static ru.ispras.microtesk.model.vliw.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.vliw.TempVars;
import ru.ispras.microtesk.model.vliw.op.BFF;
import ru.ispras.microtesk.model.Immediate;
import ru.ispras.microtesk.model.IsaPrimitive;

/**
 * The {@code DecoderBFF} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderBFF extends DecoderItem {
  private static DecoderBFF instance = null;

  public static DecoderBFF get() {
    if (null == instance) {
      instance = new DecoderBFF();
    }
    return instance;
  }

  private DecoderBFF() {
    super(
        32,
        true,
        "01000101000000000000000000000000",
        "11111111111000110000000000000000"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    final TempVars vars__ = (TempVars) TempVars.newFactory().create();

    Immediate cc = null;
    IsaPrimitive offset = null;

    if (!matchNextOpc(image, BitVector.valueOf("01000101000", 2, 11))) {
      return null;
    }
    cc = readNextImmediate(image, COND_CODE);
    if (!matchNextOpc(image, BitVector.valueOf("00", 2, 2))) {
      return null;
    }
    offset = (IsaPrimitive) readNextPrimitive(image, DecoderBRANCH_OFFSET.get());
    if (null == offset) {
      return null;
    }

    return newResult(new BFF(cc, offset));
  }
}
