/*
 * Copyright (c) ISP RAS (http://www.ispras.ru)
 * All Rights Reserved
 *
 * Ivannikov Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vmem.mmu.sim;

import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.mmu.model.sim.*;
import ru.ispras.fortress.data.types.bitvector.*;

/**
 * The {@code PageTable} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class PageTable extends MmuMapping<PageTable.Entry, VA> {
  private static PageTable instance = null;

  public static PageTable get() {
    if (null == instance) {
      instance = new PageTable();
    }
    return instance;
  }

  public static final class Entry implements Data {
    public final BitVector vpn;
    public final BitVector pfn;
    public final BitVector unused;

    public Entry() {
      this.vpn = BitVector.newEmpty(6);
      this.pfn = BitVector.newEmpty(6);
      this.unused = BitVector.newEmpty(4);
    }

    public Entry(final BitVector value) {
      this();
      asBitVector().assign(value);
    }

    public void assign(final Entry other) {
      this.vpn.assign(other.vpn);
      this.pfn.assign(other.pfn);
      this.unused.assign(other.unused);
    }

    @Override
    public BitVector asBitVector() {
      return BitVector.newMapping(
          unused,
          pfn,
          vpn
          );
    }

    @Override
    public String toString() {
      return String.format(
          "Entry [vpn=0x%s, pfn=0x%s, unused=0x%s]",
          vpn.toHexString(),
          pfn.toHexString(),
          unused.toHexString()
          );
    }
  }
  private static final Indexer<VA> INDEXER = new Indexer<VA>() {
    @Override
    public BitVector getIndex(final VA va) {
      return va.value.field(13, 8);
    }
  };

  private static final Matcher<PageTable.Entry, VA> MATCHER = new Matcher<PageTable.Entry, VA>() {
    @Override
    public boolean areMatching(final PageTable.Entry data, final VA va) {
      return va.value.field(13, 8).equals(data.vpn);
    }
  };

  private PageTable() {
    super(
      new BigInteger("64", 10),
      1,
      PolicyId.NONE,
      INDEXER,
      MATCHER
      );
  }

  @Override
  protected Mmu<VA> getMmu() {
    return vmem.get();
  }

  @Override
  protected VA newAddress() {
    return new VA();
  }

  @Override
  protected Entry newData(final BitVector value) {
    return new Entry(value);
  }

  @Override
  protected int getDataBitSize() {
    return 16;
  }
}
